Imports CKAccount.CC
Imports System.IO
Imports System.Reflection.Assembly

Public Class F1000_Menu

    Const F_NAME As String = "Menu"

    ''' <summary>
    ''' (e){^NbNCxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Btn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _
            btnAMaster.Click, _
            btnJournal.Click, _
            btnGL.Click, _
            btnCommute.Click, _
            btnTBalance.Click, _
            btnInitialSet.Click, _
            btnCash.Click, _
            btnBSPL.Click, _
            btnFixedAsset.Click, _
            btnDepreciation.Click, _
            btnMaintain.Click

        Dim btn As Button = CType(sender, Button)
        Dim sname As String = btn.Name

        Dim oform As Form
        Select Case sname
            Case "btnAMaster"      ' [Ȗڃ}X^]
                oform = New F2010_AccountMaster

            Case "btnInitialSet"   ' [ݒ]
                oform = New F3000_InitialSet

            Case "btnJournal"      ' [d]
                oform = New F3010_Journal

            Case "btnCommute"      ' [ʔ]
                oform = New F3020_Commute

            Case "btnGL"           ' [茳]
                oform = New F3030_GeneralLedger

            Case "btnCash"         ' [o[]
                oform = New F3040_CashIO

            Case "btnTBalance"     ' [Z\]
                oform = New F3100_TBalance

            Case "btnBSPL"         ' [Z\]
                oform = New F3200_BSPL

            Case "btnMaintain"     ' [eiX]
                oform = New F9000_Maintenance

            Case Else
                ShowMsg("H@", MSG_EXC)
                Exit Sub

        End Select

        ControlsEnabledChange(False)
        Application.DoEvents()
        oform.Show()

        ControlsEnabledChange(True)
        Me.Hide()
    End Sub

    ''' <summary>
    ''' [I]{^NbNCxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnEnd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
            Handles btnEnd.Click

        '_toNext = False
        Me.Close()
    End Sub

    ''' <summary>
    ''' [Form_Closing]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Form_Closing(ByVal sender As Object, ByVal e As FormClosingEventArgs) _
            Handles Me.FormClosing

        Const SAVE_FOLDER As String = "Backup"

        'If Not _toNext Then
        '*** AvP[VstH_[擾
        Dim apath As String = Application.StartupPath
        If Not apath.EndsWith("\") Then apath += "\"
        '*** obNAbvDBۑtH_[擾
        Dim sfolder As String = apath & SAVE_FOLDER  ' obNAbvDBۑtH_[
        If Not Directory.Exists(sfolder) Then Directory.CreateDirectory(sfolder)

        '*** DBҏWĂꍇ(UpdateDB=True)̍œK
        If UpdateDB Then
            If Not OptimizeDB(FILE_FOLDER, sfolder) Then End
        End If

        '*** ۑ߂obNAbvDB̊mFƏ
        CheckBackup(apath, sfolder)
        End

    End Sub

    ''' <summary>
    ''' [Form_Load]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Form_Load(ByVal sender As Object, ByVal e As System.EventArgs) _
            Handles MyBase.Load

        SetForm(Me)

        Dim ver As String = GetExecutingAssembly().GetName().Version.ToString()
        Me.Text += " (Ver " + ver + ")"
    End Sub


    ''' <summary>
    ''' [OptimizeDB]\bhFDB̍œKƃobNAbv
    ''' </summary>
    ''' <param name="vpath">CDBzutH_[</param>
    ''' <param name="vsfolder">obNAbvDBۑtH_[</param>
    ''' <returns></returns>
    ''' <remarks>[Form_Closing]ďo</remarks>
    Private Function OptimizeDB(ByVal vpath As String, ByVal vsfolder As String) As Boolean

        Const DB_OPT As String = "opt.mdb"
        Const PRE_CNST As String = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source="

        Dim method As String = New StackFrame(0).GetMethod.Name

        Try
            '*** f[^x[X̍œK
            Dim dbOld As String = vpath & ACCESS_DB         ' JgDB
            Dim dbOpt As String = vpath & DB_OPT            ' œKDB
            If File.Exists(dbOpt) Then File.Delete(dbOpt)
            Dim cnstOld As String = PRE_CNST & dbOld
            Dim cnstOpt As String = PRE_CNST & dbOpt
            Dim JRO As New JRO.JetEngine
            JRO.CompactDatabase(cnstOld, cnstOpt)

            '*** JgDBobNAbvDBƂ
            Dim ymd As String = Date2Ymd(Date.Now)
            Dim dbBu As String = vsfolder & "\" & _
                    ACCESS_DB.Substring(0, ACCESS_DB.Length - 4) & ymd & ".mdb"
            If File.Exists(dbBu) Then File.Delete(dbBu)
            File.Move(dbOld, dbBu)

            '*** œKDBJgDBɈړ
            File.Move(dbOpt, dbOld)

            Return True

        Catch ex As Exception
            ShowCatchMsg(F_NAME, method, ex)
            Return False
        End Try

    End Function

    ''' <summary>
    ''' [CheckBackup]\bhFۑ߂obNAbvDB̊mFƏ
    ''' </summary>
    ''' <param name="vpath">AvP[VstH_[</param>
    ''' <param name="vsfolder">obNAbvDBۑtH_[</param>
    ''' <remarks>[Form_Closing]ďo</remarks>
    Private Sub CheckBackup(ByVal vpath As String, ByVal vsfolder As String)

        Dim method As String = New StackFrame(0).GetMethod.Name

        Dim i1 As Integer = ACCESS_DB.Length - ".mdb".Length   ' DB̊gq
        Dim i2 As Integer = "yyyymmdd".Length

        Try
            Dim dateLimit As Date = Date.Now.AddDays(0 - DBSaveLimit)
            Dim ilimit As Integer = Convert.ToInt32(Date2Ymd(dateLimit))
            Dim symd As String = String.Empty   ' Ver1.3.0Œǉ
            Dim iymd As Integer
            Dim fname As String = String.Empty
            Dim dbase As New List(Of String)
            Dim msg As String = "ȉ̃obNAbvf[^x[X͕ۑԂ߂Ă܂B" _
                    & vbNewLine & "̃f[^x[X폜܂H" & vbNewLine
            For Each db As String In Directory.GetFiles(vsfolder)
                fname = Path.GetFileName(db)
                If fname.Length = ACCESS_DB.Length + i2 Then   ' Ver1.3.0Œǉ
                    symd = fname.Substring(i1, i2)
                    If Ymd2Date(symd) <> ERR_DATE Then
                        iymd = Convert.ToInt32(symd)
                        If iymd < ilimit Then
                            dbase.Add(db)
                            msg += vbNewLine & Space(6) & fname
                        End If
                    End If

                End If
            Next

            If dbase.Count > 0 AndAlso Not MsgCanceled(msg) Then
                For i As Integer = 0 To dbase.Count - 1
                    File.Delete(dbase(i))
                Next
            End If

        Catch ex As Exception
            ShowCatchMsg(F_NAME, method, ex)
        End Try
    End Sub

    ''' <summary>
    ''' [ControlsEnabledChange]\bh
    ''' </summary>
    ''' <param name="vbool"></param>
    ''' <remarks></remarks>
    Private Sub ControlsEnabledChange(ByVal vbool As Boolean)

        For Each ctrl As Control In Panel1.Controls
            ctrl.Enabled = vbool
        Next
        btnDepreciation.Enabled = False
        btnFixedAsset.Enabled = False
        btnEnd.Enabled = vbool
        If vbool Then
            Me.Cursor = Cursors.Default
        Else
            Me.Cursor = Cursors.WaitCursor
        End If
    End Sub

End Class
