Imports CKAccount.CC
Imports System.Data.OleDb

Public Class F2014_ACodeAlter

    Const F_NAME As String = "ACodeAlter"

    Private _pleft As Integer
    Private _ptop As Integer
    Private _code As String
    Private _complement As String
    Private _aname As String

    ''' <summary>
    ''' [ParentLeft]vpeB
    ''' </summary>
    ''' <value></value>
    ''' <remarks></remarks>
    Public WriteOnly Property ParentLeft() As Integer
        Set(ByVal Value As Integer)
            _pleft = Value
        End Set
    End Property

    ''' <summary>
    ''' [ParentTop]vpeB
    ''' </summary>
    ''' <value></value>
    ''' <remarks></remarks>
    Public WriteOnly Property ParentTop() As Integer
        Set(ByVal Value As Integer)
            _ptop = Value
        End Set
    End Property

    ''' <summary>
    ''' [Complement]vpeB
    ''' </summary>
    ''' <value></value>
    ''' <remarks></remarks>
    Public WriteOnly Property Complement() As String
        Set(ByVal Value As String)
            _complement = Value
        End Set
    End Property

    ''' <summary>
    ''' [Name2014]vpeB
    ''' </summary>
    ''' <value></value>
    ''' <remarks></remarks>
    Public WriteOnly Property Name2014() As String
        Set(ByVal Value As String)
            _aname = Value
        End Set
    End Property

    ''' <summary>
    ''' [Code]vpeB
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Code() As String
        Get
            Return _code
        End Get
        Set(ByVal Value As String)
            _code = Value
        End Set
    End Property


    ''' <summary>
    ''' [ύX]{^NbNCxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnAlter_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles btnAlter.Click

        Dim method As String = New StackFrame(0).GetMethod.Name

        Try
            btnAlter.Enabled = False
            Dim newcode As String = txtNewCode.Text.Trim
            Dim oldcode As String = lblOldCode.Text
            Dim msg As String = String.Empty

            Using cn As New OleDbConnection(CnSt)
                cn.Open()

                '*** DBNewCode邩mF
                Dim sSQL As String = "SELECT Ȗ" & _
                                    " FROM T_Ȗڃ}X^" & _
                                    " WHERE ȖC = @newcode"
                Using da As New OleDbDataAdapter(sSQL, cn)
                    da.SelectCommand.Parameters.AddWithValue("@newcode", newcode)
                    Dim dt As New DataTable
                    da.Fill(dt)
                    If dt.Rows.Count > 0 Then
                        txtNewCode.BackColor = Color.Red
                        msg = "R[h [" & newcode & "] ͌ݎgĂ܂B"
                        cn.Close()
                        ShowMsg(msg, MSG_EXC)
                        txtNewCode.BackColor = Color.White
                        txtNewCode.Focus()
                        Exit Sub
                    End If
                End Using

                '*** ύX{ۂ̊mF  ۂ̏ꍇɂ́AExit Sub
                msg = "R[h [" & oldcode & "]  VR[h [" & newcode & _
                        "] ɕύX܂B"
                If MsgCanceled(msg) Then
                    cn.Close()
                    btnAlter.Enabled = True
                    txtNewCode.Focus()
                    txtNewCode.SelectAll()
                    Exit Sub
                End If

                Dim sSQL2 As String = "UPDATE T_Ȗڃ}X^" & _
                                    " SET ȖC = @newcode2" & _
                                    " WHERE ȖC = @oldcode2"
                Using cmd2 As New OleDbCommand(sSQL2, cn)
                    cmd2.Parameters.AddWithValue("@newcode2", newcode)
                    cmd2.Parameters.AddWithValue("@oldcode2", oldcode)
                    cmd2.ExecuteNonQuery()
                End Using

                cn.Close()
            End Using

            '*** R[h̏ꍇ̏
            CheckSpecialCode(oldcode, newcode)

            '*** IbZ[W
            ShowMsg("R[hύXI܂B", MSG_INF)
            UpdateDB = True

            _code = newcode
            Me.Close()

        Catch ex As Exception
            ShowCatchMsg(F_NAME, method, ex)
        End Try

    End Sub

    ''' <summary>
    ''' [߂]{^NbNCxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnBack_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles btnBack.Click
        'txtNewCode.Text = String.Empty
        'txtNewCode.Focus()
        Me.Close()
    End Sub

    ''' <summary>
    ''' [Form_Load]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Form_Load(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles MyBase.Load

        Me.Top = _ptop
        Me.Left = _pleft

        lblOldCode.Text = _code
        _code = String.Empty
        lblName.Text = _aname
        txtNewCode.MaxLength = CodeLenAccount
    End Sub

    ''' <summary>
    ''' [txtNewCode_Enter]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub txtNewCode_Enter(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles txtNewCode.Enter
        txtNewCode.SelectAll()
    End Sub

    ''' <summary>
    ''' [txtNewCode_KeyDown]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub txtNewCode_KeyDown(ByVal sender As Object, ByVal e As KeyEventArgs) _
            Handles txtNewCode.KeyDown
        CtrlKeyDown(Me, e)
    End Sub

    ''' <summary>
    ''' [txtNewCode_TextChanged]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub txtNewCode_TextChanged(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles txtNewCode.TextChanged

        If txtNewCode.Text.Trim.Length = CodeLenAccount Then
            '*** txtNewCodeR[hɒBƂ
            btnAlter.Enabled = True
        Else
            btnAlter.Enabled = False
        End If
    End Sub

    ''' <summary>
    ''' [txtNewCode_Validating]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub txtNewCode_Validating(ByVal sender As System.Object, _
            ByVal e As System.ComponentModel.CancelEventArgs) Handles txtNewCode.Validating

        If ActiveControl Is btnBack Then Exit Sub

        Dim code As String = txtNewCode.Text.Trim
        If Not IsDigit(code) Or code.Length <> CodeLenAccount Then
            Dim msg As String = "ȖڃR[h́A" & CodeLenAccount.ToString _
                    & "̐œ͂ĂB"
            ShowMsg(msg, MSG_EXC)
            e.Cancel = True
        End If
    End Sub


    ''' <summary>
    ''' [CheckSpecialCode]\bh
    ''' </summary>
    ''' <param name="vold"></param>
    ''' <param name="vnew"></param>
    ''' <remarks></remarks>
    Private Sub CheckSpecialCode(ByVal vold As String, ByVal vnew As String)

        Select Case vold
            Case AcCodeCash
                AcCodeCash = vnew

            Case AcCodeCommute
                AcCodeCommute = vnew

            Case AcCodeProfitPY
                AcCodeProfitPY = vnew

            Case AcCodeSales
                AcCodeSales = vnew

            Case AcCodeShokuti
                AcCodeShokuti = vnew
        End Select
    End Sub
End Class