Imports CKAccount.CC
Imports System.Data.OleDb

Public Class F3000_InitialSet

    Const F_NAME As String = "InitialSet"

    Const GRIDROW_COUNT As Integer = 14   ' 
    Const MSG_1YEAR As String = "Nx͎ݒ肵Ă"
    Const MSG_NODATA As String = "Nx̊ݒ͖ݒł"
    Const TYPE_ASSET As String = "Y"
    Const TYPE_CAPITAL As String = "{"
    Const TYPE_DEBT As String = ""
    Const TYPE_INCOME As String = ""
    Const TYPE_EXPENSE As String = "o"

    Private _cbxYearWork As Boolean = False   ' FillCbxYear() ̊ԁACxg̍쓮~߂
    Private _cbxYearWork2 As Boolean = True
    Private _gridClicked As Boolean = False
    Private _is1stYear As Boolean = False
    Private _year As String = String.Empty

    ''' <summary>
    ''' [ǉ]{^NbNCxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnAdd_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles btnAdd.Click

        Dim method As String = New StackFrame(0).GetMethod.Name

        Dim syen As String = txtYen.Text.Trim.Replace(",", "")
        Dim msg As String = String.Empty

        If syen.Length = 0 Then
            ShowMsg("z͂ĂB", MSG_EXC)
            txtYen.Focus()
            Exit Sub
        End If

        Dim syear As String = cbxYear.Text
        Dim cbxText As String = cbxAccount.Text
        Dim code As String = cbxText.Substring(0, CodeLenAccount)
        Dim account As String = cbxText.Substring(CodeLenAccount + 2)

        msg = "[" & account & "] ̊ݒǉ܂B"
        If MsgCanceled(msg) Then Exit Sub

        Using cn As New OleDbConnection(CnSt)
            cn.Open()

            Dim sSQL As String = "INSERT INTO T_ݒ (Nx, ȖC, z)" & _
                                " VALUES (@year, @code, @yen)"
            Try
                Using cmd As New OleDbCommand(sSQL, cn)
                    cmd.Parameters.AddWithValue("@year", syear)
                    cmd.Parameters.AddWithValue("@code", code)
                    cmd.Parameters.AddWithValue("@yen", syen)
                    cmd.ExecuteNonQuery()
                End Using
            Catch ex As Exception
                cn.Close()
                ShowCatchMsg(F_NAME, method, ex)
                Exit Sub
            End Try

            cn.Close()
        End Using

        ShowMsg("ǉIB", MSG_INF)
        UpdateDB = True

        ShowGrid()
        cbxAccount.Text = cbxText
    End Sub

    ''' <summary>
    ''' [ݒ]{^NbNCxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnAutoSet_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles btnAutoSet.Click

        If _is1stYear Then
            If AutoSet1stYear() Then
                rdoManual.Enabled = True
                rdoRemove.Enabled = True
                lblMsg.Text = MSG_NODATA
                _is1stYear = False
            End If
        Else
            AutoSetAfterYear()
        End If
    End Sub

    ''' <summary>
    ''' [߂]{^NbNCxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnBack_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles btnBack.Click
        Me.Close()
    End Sub

    ''' <summary>
    ''' [NA]{^NbNCxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnClear_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles btnClear.Click

        cbxAccount.SelectedIndex = -1
        txtYen.Text = String.Empty
        cbxAccount.Focus()
    End Sub

    ''' <summary>
    ''' [폜]{^NbNCxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnDelete_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles btnDelete.Click

        Dim method As String = New StackFrame(0).GetMethod.Name

        Dim syear As String = cbxYear.Text
        Dim code As String = cbxAccount.Text.Substring(0, CodeLenAccount)
        Dim account As String = cbxAccount.Text.Substring(CodeLenAccount + 2)

        Dim msg As String = "[" & account & "] ̊ݒ폜܂B"
        If MsgCanceled(msg) Then Exit Sub

        Try
            Using cn As New OleDbConnection(CnSt)
                cn.Open()

                Dim sSQL As String = "DELETE FROM T_ݒ" & _
                                    " WHERE Nx = @year AND ȖC = @code"

                Using cmd As New OleDbCommand(sSQL, cn)
                    cmd.Parameters.AddWithValue("@year", syear)
                    cmd.Parameters.AddWithValue("@code", code)
                    cmd.ExecuteNonQuery()
                End Using

                cn.Close()
            End Using

            ShowMsg("폜IB", MSG_INF)
            UpdateDB = True

            ShowGrid()

        Catch ex As Exception
            ShowCatchMsg(F_NAME, method, ex)
        End Try
    End Sub

    ''' <summary>
    ''' [ݒ폜]{^NbNCxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnRemove_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles btnRemove.Click

        Dim method As String = New StackFrame(0).GetMethod.Name

        Dim syear As String = cbxYear.Text
        Dim msg As String = syear & "Nx̊ݒe폜܂B"
        If MsgCanceled(msg) Then Exit Sub

        Try
            Using cn As New OleDbConnection(CnSt)
                cn.Open()
                Dim sSQL As String = "DELETE FROM T_ݒ" & _
                                    " WHERE Nx = @year"
                Using cmd As New OleDbCommand(sSQL, cn)
                    cmd.Parameters.AddWithValue("@year", syear)
                    cmd.ExecuteNonQuery()
                End Using

                cn.Close()
            End Using

            ShowMsg("ݒ폜IB", MSG_INF)
            UpdateDB = True

            If Not ExistData() Then
                rdoManual.Enabled = False
                rdoRemove.Enabled = False
                lblMsg.Text = MSG_1YEAR
                _is1stYear = True
            Else
                lblMsg.Text = MSG_NODATA
            End If
            ClearForm()

        Catch ex As Exception
            ShowCatchMsg(F_NAME, method, ex)
        End Try
    End Sub

    ''' <summary>
    ''' [C]{^NbNCxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnUpdate_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles btnUpdate.Click

        Dim method As String = New StackFrame(0).GetMethod.Name

        Dim syen As String = txtYen.Text.Trim.Replace(",", "")

        If syen.Length = 0 Then
            ShowMsg("z͂ĂB", MSG_EXC)
            txtYen.Focus()
            Exit Sub
        End If

        Dim dyen As Decimal = Convert.ToDecimal(syen)
        Dim syear As String = cbxYear.Text
        Dim code As String = cbxAccount.Text.Substring(0, CodeLenAccount)
        Dim account As String = cbxAccount.Text.Substring(CodeLenAccount + 2)

        Dim msg As String = "[" & account & "] ̊ݒC܂B"
        If MsgCanceled(msg) Then Exit Sub

        Try
            Using cn As New OleDbConnection(CnSt)
                cn.Open()

                Dim sSQL As String = "UPDATE T_ݒ" & _
                                    " SET z = @yen" & _
                                    " WHERE Nx = @year AND ȖC = @code"
                Using cmd As New OleDbCommand(sSQL, cn)
                    cmd.Parameters.AddWithValue("@yen", dyen)
                    cmd.Parameters.AddWithValue("@year", syear)
                    cmd.Parameters.AddWithValue("@code", code)
                    cmd.ExecuteNonQuery()
                End Using

                cn.Close()
            End Using

            ShowMsg("CIB", MSG_INF)
            UpdateDB = True

            ShowGrid()

        Catch ex As Exception
            ShowCatchMsg(F_NAME, method, ex)
        End Try
    End Sub

    ''' <summary>
    ''' [Cbx_KeyDown]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Cbx_KeyDown(ByVal sender As System.Object, _
            ByVal e As KeyEventArgs) Handles cbxYear.KeyDown, cbxAccount.KeyDown
        CtrlKeyDown(Me, e)
    End Sub

    ''' <summary>
    ''' [cbxAccount_SIChanged]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub cbxAccount_SIChanged(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles cbxAccount.SelectedIndexChanged

        btnAdd.Enabled = False
        btnUpdate.Enabled = False
        btnDelete.Enabled = False

        If _gridClicked Then
            _gridClicked = False
            Exit Sub
        End If
        If cbxAccount.SelectedIndex < 0 Then Exit Sub

        If grdView.Visible Then
            Dim code As String = cbxAccount.Text.Substring(0, CodeLenAccount)
            Dim index As Integer = GridRowIndex(grdView, "ȖC", code)
            If index > -1 Then
                Dim dyen As Decimal = _
                    Convert.ToDecimal(grdView.Rows(index).Cells("z").Value)
                txtYen.Text = dyen.ToString("#,##0")
                grdView.Rows(index).Selected = True

                Dim fdsrindex As Integer = index - GRIDROW_COUNT + 1
                If fdsrindex < 0 Then fdsrindex = 0
                grdView.FirstDisplayedScrollingRowIndex = fdsrindex

                btnUpdate.Enabled = True
                btnDelete.Enabled = True
            Else
                txtYen.Text = String.Empty
                grdView.ClearSelection()
                btnAdd.Enabled = True
            End If

        Else
            btnAdd.Enabled = True
        End If
    End Sub

    ''' <summary>
    ''' [cbxYear_SIChanged]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub cbxYear_SIChanged(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles cbxYear.SelectedIndexChanged

        If Not _cbxYearWork2 Then
            _cbxYearWork2 = True
            Return
        End If

        If grdView.Visible And _year.Length > 0 Then
            If Not CheckBalance(_year) Then
                _cbxYearWork2 = False
                cbxYear.Text = _year
                Exit Sub
            End If
        End If

        If _cbxYearWork Then ShowGrid()
        _year = cbxYear.Text
    End Sub

    ''' <summary>
    ''' [Form_Closing]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Form_Closing(ByVal sender As System.Object, _
            ByVal e As FormClosingEventArgs) Handles MyBase.FormClosing

        F1000_Menu.Show()
    End Sub

    ''' <summary>
    ''' [Form_Load]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Form_Load(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles MyBase.Load

        SetForm(Me)
        InitializeForm()
    End Sub

    ''' <summary>
    ''' [grdView_Click]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub grdView_Click(ByVal sender As Object, ByVal e As System.EventArgs) _
            Handles grdView.Click

        If Not rdoManual.Checked Then
            grdView.ClearSelection()
            Exit Sub
        End If

        With grdView.Rows(grdView.CurrentRow.Index)
            If grdView.SelectedRows.Count > 0 Then
                _gridClicked = True
                Dim code As String = .Cells("ȖC").Value.ToString
                Dim account As String = .Cells("Ȗ").Value.ToString
                cbxAccount.Text = code & ") " & account
                txtYen.Text = Convert.ToInt32(.Cells("z").Value).ToString("#,##0")

                btnUpdate.Enabled = True
                btnDelete.Enabled = True
                txtYen.Focus()
            End If
        End With
    End Sub

    ''' <summary>
    ''' [RdoBtn_CheckedChanged]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub RdoBtn_CheckedChanged(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles _
            rdoRemove.CheckedChanged, rdoManual.CheckedChanged, rdoAuto.CheckedChanged

        If Not CType(sender, RadioButton).Checked Then Exit Sub

        If sender Is rdoAuto Then
            cbxAccount.SelectedIndex = -1
            txtYen.BackColor = SystemColors.ActiveBorder
            txtYen.Text = String.Empty
            Panel2.Enabled = False
            btnRemove.Enabled = False
            If grdView.Visible Then
                ShowMsg("̊ݒ͓o^Ă܂B", MSG_EXC)
                rdoAuto.Checked = False
            Else
                btnAutoSet.Enabled = True
                btnAutoSet.Focus()
            End If

        ElseIf sender Is rdoManual Then
            btnAutoSet.Enabled = False
            txtYen.BackColor = SystemColors.Window
            Panel2.Enabled = True
            btnRemove.Enabled = False
            cbxAccount.Focus()

        Else
            btnAutoSet.Enabled = False
            cbxAccount.SelectedIndex = -1
            txtYen.BackColor = SystemColors.ActiveBorder
            txtYen.Text = String.Empty
            Panel2.Enabled = False
            If grdView.Visible Then
                btnRemove.Enabled = True
                grdView.ClearSelection()
                btnRemove.Focus()

            Else
                ShowMsg("̊ݒ͖ݒłB", MSG_EXC)
                rdoRemove.Checked = False
            End If

        End If
    End Sub

    ''' <summary>
    ''' [txtYen_KeyDown]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub txtYen_KeyDown(ByVal sender As System.Object, _
            ByVal e As KeyEventArgs) Handles txtYen.KeyDown
        CtrlKeyDown(Me, e)
    End Sub

    ''' <summary>
    ''' [txtYen_Validating]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub txtYen_Validating(ByVal sender As System.Object, _
            ByVal e As System.ComponentModel.CancelEventArgs) Handles txtYen.Validating

        If ActiveControl.Name = btnBack.Name Then Exit Sub

        ValidateTBYen(txtYen)
    End Sub


    ''' <summary>
    ''' [AutoSet1stYear]\bhFNx̎ݒ
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks>[btnAutoSet]ďo</remarks>
    Private Function AutoSet1stYear() As Boolean

        Dim method As String = New StackFrame(0).GetMethod.Name

        Dim syear As String = cbxYear.Text
        If MsgCanceled(syear & "Nx̎ݒs܂B") Then Exit Function

        FormDisabled(Me)

        Using cn As New OleDbConnection(CnSt)
            cn.Open()

            Dim sSQL1 As String = "SELECT ȖC " & _
                                " FROM T_Ȗڃ}X^" & _
                                " ORDER BY ȖC"
            Using da1 As New OleDbDataAdapter(sSQL1, cn)
                Dim dt1 As New DataTable
                da1.Fill(dt1)

                '*** LȑSȖڂ̏l0ɐݒ肷
                Dim tran As OleDbTransaction = cn.BeginTransaction
                Dim sSQL2 As String = String.Empty
                Try
                    For i1 As Integer = 0 To dt1.Rows.Count - 1
                        Dim code As String = dt1.Rows(i1)(0).ToString
                        sSQL2 = "INSERT INTO T_ݒ (Nx, ȖC, z)" & _
                                " VALUES (@year, @code, 0)"
                        Using cmd2 As New OleDbCommand(sSQL2, cn)
                            cmd2.Parameters.AddWithValue("@year", syear)
                            cmd2.Parameters.AddWithValue("@code", code)
                            cmd2.Transaction = tran
                            cmd2.ExecuteNonQuery()
                        End Using
                    Next
                    tran.Commit()

                Catch ex As Exception
                    tran.Rollback()
                    cn.Close()
                    FormEnabled(Me)
                    ShowCatchMsg(F_NAME, method, ex)
                    Return False
                End Try
            End Using

            cn.Close()
        End Using
        FormEnabled(Me)
        ShowMsg("ݒI܂B", MSG_INF)
        UpdateDB = True

        ShowGrid()
        Return True
    End Function

    ''' <summary>
    ''' [CheckBalance]\bh
    ''' </summary>
    ''' <param name="vyear"></param>
    ''' <returns></returns>
    ''' <remarks>[cbxYear_SIChanged]ďo</remarks>
    Private Function CheckBalance(ByVal vyear As String) As Boolean

        Dim method As String = New StackFrame(0).GetMethod.Name

        Dim debtor As Long
        Dim creditor As Long

        Try
            Using cn As New OleDbConnection(CnSt)
                '*** ؕz̍v
                Dim sSQL1 As String = "SELECT SUM(z) AS SUMYEN" & _
                                    " FROM V_ݒ" & _
                                    " WHERE Nx = @year1 AND  = @type1"
                Using da1 As New OleDbDataAdapter(sSQL1, cn)
                    da1.SelectCommand.Parameters.AddWithValue("@year1", vyear)
                    da1.SelectCommand.Parameters.AddWithValue("@type1", TYPE_ASSET)
                    Dim dt1 As New DataTable
                    da1.Fill(dt1)
                    debtor = Convert.ToInt64(dt1.Rows(0)("SUMYEN"))
                End Using

                '*** ؕz̍v
                Dim sSQL2 As String = "SELECT SUM(z) AS SUMYEN" & _
                                    " FROM V_ݒ" & _
                                    " WHERE Nx = @year2 AND  IN (@type21, @type22)"
                Using da2 As New OleDbDataAdapter(sSQL2, cn)
                    da2.SelectCommand.Parameters.AddWithValue("@year2", vyear)
                    da2.SelectCommand.Parameters.AddWithValue("@type21", TYPE_DEBT)
                    da2.SelectCommand.Parameters.AddWithValue("@type22", TYPE_CAPITAL)
                    Dim dt2 As New DataTable
                    da2.Fill(dt2)
                    creditor = Convert.ToInt64(dt2.Rows(0)("SUMYEN"))
                End Using
            End Using

            If debtor = creditor Then
                Return True
            Else
                Dim msg As String = "ؕvzF" & debtor.ToString("#,##0") & vbNewLine _
                        & "ݕvzF" & creditor.ToString("#,##0") & vbNewLine & vbNewLine _
                        & "ؕƑݕ̍vzv܂B"
                ShowMsg(msg, MSG_EXC)
                Return False
            End If

        Catch ex As Exception
            ShowCatchMsg(F_NAME, method, ex)
            Return False
        End Try

    End Function

    ''' <summary>
    ''' [ExistData]\bhF[T_ݒ]e[ũf[^LԂ
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks>[btnRemove_Click],[InitializeForm]ďo</remarks>
    Private Function ExistData() As Boolean

        Dim method As String = New StackFrame(0).GetMethod.Name

        Try
            Using cn As New OleDbConnection(CnSt)
                Dim sSQL As String = "SELECT ȖC" & _
                                    " FROM T_ݒ"
                Using da As New OleDbDataAdapter(sSQL, cn)
                    Dim dt As New DataTable
                    da.Fill(dt)
                    If dt.Rows.Count = 0 Then
                        Return False
                    Else
                        Return True
                    End If
                End Using
            End Using

        Catch ex As Exception
            ShowCatchMsg(F_NAME, method, ex)
        End Try
    End Function

    ''' <summary>
    ''' [ExistYearData]\bhF\Nx̊ݒf[^̗LԂ
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks>[ShowGrid]ďo</remarks>
    Private Function ExistYearData() As Boolean

        Dim method As String = New StackFrame(0).GetMethod.Name

        Dim syear As String = cbxYear.Text
        Try
            Using cn As New OleDbConnection(CnSt)
                Dim sSQL As String = "SELECT ȖC" & _
                                    " FROM T_ݒ" & _
                                    " WHERE Nx = @year"
                Using da As New OleDbDataAdapter(sSQL, cn)
                    da.SelectCommand.Parameters.AddWithValue("@year", syear)
                    Dim dt As New DataTable
                    da.Fill(dt)
                    If dt.Rows.Count = 0 Then
                        Return False
                    Else
                        Return True
                    End If
                End Using
            End Using

        Catch ex As Exception
            ShowCatchMsg(F_NAME, method, ex)
        End Try
    End Function

    ''' <summary>
    ''' [AutoSetAfterYear]\bhF2Nڈȍ~̎ݒ
    ''' </summary>
    ''' <remarks>[btnAutoSet]ďo</remarks>
    Private Sub AutoSetAfterYear()

        Dim method As String = New StackFrame(0).GetMethod.Name

        Dim msg As String = String.Empty
        Dim syear As String = cbxYear.Text
        Dim preyear As String = (Int32.Parse(syear) - 1).ToString

        Using cn As New OleDbConnection(CnSt)
            cn.Open()

            Dim sSQL1 As String = "SELECT ȖC, z, " & _
                                    " FROM V_Z\" & _
                                    " WHERE Nx = @preyear"
            Using da1 As New OleDbDataAdapter(sSQL1, cn)
                da1.SelectCommand.Parameters.AddWithValue("@preyear", preyear)
                Dim dt1 As New DataTable
                da1.Fill(dt1)
                '*** ONxZ\̍쐬mF  쐬ĂȂꍇɂ [Exit Sub]
                If dt1.Rows.Count = 0 Then
                    msg = "ONx̐Z\쐬Ȃ̂ŁA" & syear & _
                        "Nx̎ݒ͂ł܂"
                    ShowMsg(msg, MSG_EXC)
                    cn.Close()
                    Exit Sub
                End If

                '*** ݒsۂ̊mF
                msg = syear & "Nx̎ݒs܂B"
                If MsgCanceled(msg) Then
                    cn.Close()
                    Exit Sub
                End If

                '*** ʂ𖳌
                FormDisabled(Me)

                '*** ȉAݒ葀
                Dim sumAsset As Decimal = 0
                Dim sumCapital As Decimal = 0
                Dim sumDebt As Decimal = 0

                Dim tran As OleDbTransaction = cn.BeginTransaction
                Try
                    For i As Integer = 0 To dt1.Rows.Count - 1
                        Dim code As String = dt1.Rows(i).Item("ȖC").ToString
                        Dim dyen As Decimal = Convert.ToDecimal(dt1.Rows(i).Item("z"))
                        Dim type As String = dt1.Rows(i).Item("").ToString

                        '*** YAA{ڂ̂ݐݒ肷
                        If type = TYPE_ASSET Then
                            sumAsset += dyen
                            Dim sSQL2 As String = "INSERT INTO T_ݒ (Nx, ȖC, z)" & _
                                        " VALUES (@year2, @code2, @yen2)"
                            Using cmd2 As New OleDbCommand(sSQL2, cn)
                                cmd2.Parameters.AddWithValue("@year2", syear)
                                cmd2.Parameters.AddWithValue("@code2", code)
                                cmd2.Parameters.AddWithValue("@yen2", dyen)
                                cmd2.Transaction = tran
                                cmd2.ExecuteNonQuery()
                            End Using

                        ElseIf type = TYPE_DEBT Then
                            sumDebt += dyen
                            Dim sSQL3 As String = "INSERT INTO T_ݒ (Nx, ȖC, z)" & _
                                        " VALUES (@year3, @code3, @yen3)"
                            Using cmd3 As New OleDbCommand(sSQL3, cn)
                                cmd3.Parameters.AddWithValue("@year3", syear)
                                cmd3.Parameters.AddWithValue("@code3", code)
                                cmd3.Parameters.AddWithValue("@yen3", dyen)
                                cmd3.Transaction = tran
                                cmd3.ExecuteNonQuery()
                            End Using

                        ElseIf type = TYPE_CAPITAL And code <> AcCodeProfitPY Then
                            sumCapital += dyen
                            Dim sSQL4 As String = "INSERT INTO T_ݒ (Nx, ȖC, z)" & _
                                        " VALUES (@year4, @code4, @yen4)"
                            Using cmd4 As New OleDbCommand(sSQL4, cn)
                                cmd4.Parameters.AddWithValue("@year4", syear)
                                cmd4.Parameters.AddWithValue("@code4", code)
                                cmd4.Parameters.AddWithValue("@yen4", dyen)
                                cmd4.Transaction = tran
                                cmd4.ExecuteNonQuery()
                            End Using

                        ElseIf code <> AcCodeProfitPY Then
                            '*** Ao0
                            Dim sSQL5 As String = "INSERT INTO T_ݒ (Nx, ȖC, z)" & _
                                " VALUES (@year5, @code5, 0)"
                            Using cmd5 As New OleDbCommand(sSQL5, cn)
                                cmd5.Parameters.AddWithValue("@year5", syear)
                                cmd5.Parameters.AddWithValue("@code5", code)
                                cmd5.Transaction = tran
                                cmd5.ExecuteNonQuery()
                            End Using
                        End If
                    Next

                    '*** O̐ݒ
                    Dim income As Decimal = sumAsset - sumDebt - sumCapital
                    Dim sSQL6 As String = "INSERT INTO T_ݒ (Nx,ȖC,z)" & _
                        " VALUES (@year6, @code6, @yen)"
                    Using cmd6 As New OleDbCommand(sSQL6, cn)
                        cmd6.Parameters.AddWithValue("@year4", syear)
                        cmd6.Parameters.AddWithValue("@code4", AcCodeProfitPY)
                        cmd6.Parameters.AddWithValue("@yen4", income)
                        cmd6.Transaction = tran
                        cmd6.ExecuteNonQuery()
                    End Using

                    '*** TransactioñR~bg
                    tran.Commit()

                Catch ex As Exception
                    tran.Rollback()
                    FormEnabled(Me)
                    ShowCatchMsg(F_NAME, method, ex)
                    cn.Close()
                    Exit Sub
                End Try
            End Using

            cn.Close()
        End Using

        FormEnabled(Me)
        ShowMsg("ݒI܂B", MSG_INF)
        UpdateDB = True

        ShowGrid()
    End Sub

    ''' <summary>
    ''' [ClearForm]\bh
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub ClearForm()
        grdView.Visible = False
        lblMsg.Visible = True
        rdoAuto.Checked = True
    End Sub

    ''' <summary>
    ''' [FillCbxAccount]\bh
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub FillCbxAccount()

        Dim method As String = New StackFrame(0).GetMethod.Name

        cbxAccount.Items.Clear()
        Try
            Using cn As New OleDbConnection(CnSt)
                Dim sSQL As String = "SELECT ȖC, Ȗ" & _
                    " FROM T_Ȗڃ}X^" & _
                    " WHERE  IN (@asset, @debt, @capital)" & _
                    " ORDER BY ȖC"

                Using da As New OleDbDataAdapter(sSQL, cn)
                    da.SelectCommand.Parameters.AddWithValue("@asset", TYPE_ASSET)
                    da.SelectCommand.Parameters.AddWithValue("@debt", TYPE_DEBT)
                    da.SelectCommand.Parameters.AddWithValue("@capital", TYPE_CAPITAL)
                    Dim dt As New DataTable
                    da.Fill(dt)

                    ' []Ȃǂ̕K{R[ĥŁAdt.Rows.Count > 0 ƂȂ
                    For i As Integer = 0 To dt.Rows.Count - 1
                        cbxAccount.Items.Add(dt.Rows(i).Item("ȖC").ToString & ") " & _
                            dt.Rows(i).Item("Ȗ").ToString)
                    Next
                    'End If
                End Using
            End Using

        Catch ex As Exception
            ShowCatchMsg(F_NAME, method, ex)
        End Try
    End Sub

    ''' <summary>
    ''' [FillCbxYear]
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub FillCbxYear()

        For i As Integer = MinYear To MaxYear
            cbxYear.Items.Add(i.ToString)
        Next
    End Sub

    ''' <summary>
    ''' [InitializeForm]\bh
    ''' </summary>
    ''' <remarks>[Form_Load]ďo</remarks>
    Private Sub InitializeForm()

        FillCbxYear()
        FillCbxAccount()

        _cbxYearWork = True
        cbxYear.Text = Year(Now).ToString

        If Not ExistData() Then
            rdoManual.Enabled = False
            rdoRemove.Enabled = False
            rdoAuto.Checked = True
            lblMsg.Text = MSG_1YEAR
            _is1stYear = True
        Else
            lblMsg.Text = MSG_NODATA
        End If
    End Sub

    ''' <summary>
    ''' [ShowGrid]\bh
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub ShowGrid()

        Dim method As String = New StackFrame(0).GetMethod.Name

        ClearForm()
        If Not ExistYearData() Then Exit Sub

        Dim sSQL As String = "SELECT A.ȖC, M.Ȗ, A.z" & _
                            " FROM T_ݒ A LEFT OUTER JOIN T_Ȗڃ}X^ M" & _
                                " ON A.ȖC = M.ȖC" & _
                            " WHERE A.Nx = @year" & _
                                " AND  IN (@asset, @debt, @capital)" & _
                            " ORDER BY A.ȖC"
        Try
            Using cn As New OleDbConnection(CnSt)
                Dim da As New OleDbDataAdapter(sSQL, cn)
                da.SelectCommand.Parameters.AddWithValue("@year", cbxYear.Text)
                da.SelectCommand.Parameters.AddWithValue("@asset", TYPE_ASSET)
                da.SelectCommand.Parameters.AddWithValue("@debt", TYPE_DEBT)
                da.SelectCommand.Parameters.AddWithValue("@capital", TYPE_CAPITAL)
                Dim dt As New DataTable
                da.Fill(dt)

                If dt.Rows.Count = 0 Then
                    grdView.DataSource = Nothing
                    grdView.Visible = False

                Else
                    lblMsg.Visible = False
                    With grdView
                        .Visible = True
                        .DataSource = dt
                        .Columns("ȖC").Width = 60
                        .Columns("Ȗ").Width = 120
                        .Columns("z").Width = 100
                        .Columns("z").DefaultCellStyle.Alignment = _
                                DataGridViewContentAlignment.MiddleRight
                        .Columns("z").DefaultCellStyle.Format = "#,##0"
                        SetGridProperty(grdView)
                        '.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.AllCells
                        .ClearSelection()
                    End With
                    rdoManual.Checked = True
                End If
            End Using

        Catch ex As Exception
            ShowCatchMsg(F_NAME, method, ex)
        End Try
    End Sub

End Class