Imports CKAccount.CC
Imports System.Data.OleDb

Public Class F3020_Commute

    Private Const TABLE_NAME As String = "F3020_DT"
    Private Const F_NAME As String = "Commute"

    'Private _cbxYearWork As Boolean = True    ' TrueF[cbxYear_SIChanged]Lɓ삳
    Private _dt As DataTable
    Private _grid1stIndex As Integer
    Private _toJournal As Boolean = False

    ''' <summary>
    ''' [߂]{^NbNCxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnBack_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles btnBack.Click

        _toJournal = False
        Me.Close()
    End Sub

    ''' <summary>
    ''' [NA]{^NbNCxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnClear_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles btnClear.Click

        grdView.ClearSelection()
        ClearData()
    End Sub

    ''' <summary>
    ''' []{^NbNCxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnPrint_Click(ByVal sender As System.Object, _
                ByVal e As System.EventArgs) Handles btnPrint.Click

        Dim syear As String = cbxYear.Text
        Dim term As String = syear & "N11`" & syear & "N1231"

        FormDisabled(Me)
        PrintTable(_dt, term)
        FormEnabled(Me)
    End Sub

    ''' <summary>
    ''' [d]{^NbNCxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnToJournal_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles btnToJournal.Click

        _toJournal = True
        Me.Close()
    End Sub

    ''' <summary>
    ''' [C]{^NbNCxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnUpdate_Click(ByVal sender As System.Object, _
                ByVal e As System.EventArgs) Handles btnUpdate.Click

        Dim method As String = New StackFrame(0).GetMethod.Name

        Dim itemnum As String = lblItemNo.Text
        Dim detail As String = txtDetail.Text.Trim
        If NGetByteCount(detail) > 40 Then
            detail = NLeftB(detail, 40, False)
        End If
        Dim gindex As Integer = grdView.SelectedRows(0).Index

        Using cn As New OleDbConnection(CnSt)
            cn.Open()

            Try
                Dim sSQL As String = "UPDATE T_ʔ1" & _
                                    " SET  = @complement" & _
                                    " WHERE ʔ = @itemnum"
                Using cmd As New OleDbCommand(sSQL, cn)
                    cmd.Parameters.AddWithValue("@complement", detail)
                    cmd.Parameters.AddWithValue("@itemnum", itemnum)
                    cmd.ExecuteNonQuery()
                End Using

                cn.Close()

                ShowMsg("CIB", MSG_INF)
                UpdateDB = True
                _grid1stIndex = grdView.FirstDisplayedScrollingRowIndex

                ShowGrid()
                grdView.FirstDisplayedScrollingRowIndex = _grid1stIndex
                grdView.Rows(gindex).Selected = True

            Catch ex As Exception

                ShowCatchMsg(F_NAME, method, ex)
                cn.Close()
            End Try
        End Using
    End Sub

    ''' <summary>
    ''' [cbxYear_SIChanged]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub cbxYear_SIChanged(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles cbxYear.SelectedIndexChanged

        ClearData()
        If cbxYear.SelectedIndex < 0 Then Exit Sub

        _grid1stIndex = 0
        ShowGrid()
    End Sub

    ''' <summary>
    ''' [(e)Ctrls_KeyDown]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Ctrls_KeyDown(ByVal sender As System.Object, _
            ByVal e As KeyEventArgs) Handles txtDetail.KeyDown
        CtrlKeyDown(Me, e)
    End Sub

    ''' <summary>
    ''' [Form_Closing]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Form_Closing(ByVal sender As Object, _
            ByVal e As FormClosingEventArgs) Handles Me.FormClosing

        If Not _dt Is Nothing Then
            grdView.DataSource = Nothing
            _dt.Clear()
            _dt = Nothing
        End If
        If _toJournal Then
            F3010_Journal.Show()
        Else
            F1000_Menu.Show()
        End If
    End Sub

    ''' <summary>
    ''' [Form_Load]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Form_Load(ByVal sender As Object, _
            ByVal e As System.EventArgs) Handles MyBase.Load

        SetForm(Me)
        InitializeForm()
    End Sub

    ''' <summary>
    ''' [grdView_Click]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub grdView_Click(ByVal sender As Object, _
            ByVal e As System.EventArgs) Handles grdView.Click

        With grdView
            If .SelectedRows.Count > 0 Then
                Dim index As Integer = .CurrentRow.Index
                Dim ymd As String = .Rows(index).Cells("N").Value.ToString
                lblYMD.Text = ymd.Substring(0, 4) & "N" & ymd.Substring(4, 2) & "" _
                        & ymd.Substring(6, 2) & ""

                lblItemNo.Text = .Rows(index).Cells("ʔ").Value.ToString
                lblAccount.Text = .Rows(index).Cells("Ȗ").Value.ToString
                lblYen.Text = Convert.ToInt32(.Rows(index).Cells("z").Value).ToString("#,##0")
                lblComplement.Text = .Rows(index).Cells("Ev").Value.ToString
                txtDetail.Text = .Rows(index).Cells("").Value.ToString
            End If
        End With

        txtDetail.Focus()
    End Sub

    ''' <summary>
    ''' [lblItemNo_TextChanged]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub lblItemNo_TextChanged(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles lblItemNo.TextChanged

        If lblItemNo.Text.Length = 0 Then
            btnUpdate.Enabled = False
        Else
            btnUpdate.Enabled = True
        End If
    End Sub

    ''' <summary>
    ''' [txtDetail_Enter]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub txtDetail_Enter(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles txtDetail.Enter
        txtDetail.SelectAll()
    End Sub

    ''' <summary>
    ''' [txtDetail_Validating]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub txtDetail_Validating(ByVal sender As Object, _
            ByVal e As System.ComponentModel.CancelEventArgs) Handles txtDetail.Validating
        RemoveNewLine(txtDetail)
    End Sub


    ''' <summary>
    ''' [ClearData]\bh
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub ClearData()

        lblYMD.Text = String.Empty
        lblItemNo.Text = String.Empty
        lblAccount.Text = String.Empty
        lblYen.Text = String.Empty
        lblComplement.Text = String.Empty
        txtDetail.Text = String.Empty
    End Sub

    ''' <summary>
    ''' [FillCbxYear]\bh
    ''' </summary>
    ''' <remarks>[InitializeForm]ďo</remarks>
    Private Sub FillCbxYear()

        '_cbxYearWork = False
        For i As Integer = MinYear To MaxYear
            cbxYear.Items.Add(i.ToString)
        Next
        '_cbxYearWork = True
        cbxYear.Text = Date.Now.Year.ToString
    End Sub

    ''' <summary>
    ''' [InitializeForm]\bh
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub InitializeForm()

        FillCbxYear()
        SetGridProperty(grdView)
    End Sub

    ''' <summary>
    ''' [PrintTable]\bh
    ''' </summary>
    ''' <param name="vdt"></param>
    ''' <param name="vterm"></param>
    ''' <remarks></remarks>
    Private Sub PrintTable(ByVal vdt As DataTable, ByVal vterm As String)

        Const ORIGINAL_FILE As String = "ʔ.xls"
        Const TARGET_FILE As String = "ʔ.xls"

        Dim method As String = New StackFrame(0).GetMethod.Name
        Dim target As String = FILE_FOLDER & TARGET_FILE
        Dim original As String = FILE_FOLDER & ORIGINAL_FILE
        If Not System.IO.File.Exists(original) Then
            ShowMsg("[" & original & "]܂B", MSG_EXC)
            Exit Sub
        End If

        Dim dt As DataTable = vdt
        Dim exlapp As New Excel.Application
        Try
            exlapp.Visible = False
            'exlapp.Visible = True
            Try
                exlapp.Workbooks.Open(original)
            Catch ex As Exception
                exlapp.Quit()
                exlapp = Nothing
                ShowMsg("[" & ORIGINAL_FILE & "]ĂB", MSG_EXC)
                Exit Sub
            End Try

            exlapp.DisplayAlerts = False
            Dim book1 As Excel.Workbook = exlapp.ActiveWorkbook
            Try
                book1.SaveAs(target)
            Catch ex As Exception
                book1.Close()
                book1 = Nothing
                exlapp.Quit()
                exlapp = Nothing
                ShowMsg("[" & TARGET_FILE & "]ĂB", MSG_EXC)
                Exit Sub
            End Try
            exlapp.DisplayAlerts = True

            Dim sheet1 As Excel.Worksheet = CType(book1.Worksheets(1), Excel.Worksheet)
            With sheet1
                .Cells(3, "A") = vterm
                Dim iend As Integer = 5
                If dt.Rows.Count > 0 Then
                    For i As Integer = 0 To dt.Rows.Count - 1
                        .Cells(i + 5, "A") = dt.Rows(i)("N")
                        .Cells(i + 5, "B") = dt.Rows(i)("z")
                        .Cells(i + 5, "C") = dt.Rows(i)("Ev")
                        .Cells(i + 5, "D") = dt.Rows(i)("")
                        iend = i + 5
                    Next
                End If
                .Range("A5", .Cells(iend, "D")).Borders.LineStyle = Excel.XlLineStyle.xlContinuous
                .PrintOut()
            End With

            exlapp.DisplayAlerts = False
            book1.Save()
            book1.Close()
            book1 = Nothing
            exlapp.DisplayAlerts = True
            exlapp.Quit()
            exlapp = Nothing

            ShowMsg("I܂B", MSG_INF)

        Catch ex As Exception

            exlapp.DisplayAlerts = False
            For Each wbook As Excel.Workbook In exlapp.Workbooks
                wbook.Close()
            Next
            exlapp.DisplayAlerts = True
            exlapp.Quit()
            exlapp = Nothing

            ShowCatchMsg(F_NAME, method, ex)
        End Try
    End Sub

    ''' <summary>
    ''' [ShowGrid]\bh
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub ShowGrid()

        Dim method As String = New StackFrame(0).GetMethod.Name

        If Not _dt Is Nothing Then
            _dt.Clear()
            grdView.DataSource = Nothing
        End If

        Dim syear As String = cbxYear.Text
        Dim sSQL As String = "SELECT ʔ," & _
                                " N," & _
                                " z," & _
                                " Ȗ," & _
                                " Ev," & _
                                " " & _
                            " FROM V_ʔ1" & _
                            " WHERE N LIKE @year" & _
                            " ORDER BY N, ʔ"
        Try
            Using cn As New OleDbConnection(CnSt)
                Dim da As New OleDbDataAdapter(sSQL, cn)
                da.SelectCommand.Parameters.AddWithValue("@year", syear & "%")
                _dt = New DataTable
                da.Fill(_dt)

                If _dt.Rows.Count = 0 Then
                    lblMsg.Visible = True
                    grdView.Visible = False
                    btnPrint.Enabled = False
                    ClearData()

                Else
                    lblMsg.Visible = False
                    With grdView
                        .Visible = True
                        .DataSource = _dt
                        .Columns("ʔ").Visible = False
                        .Columns("z").DefaultCellStyle.Alignment = _
                                DataGridViewContentAlignment.MiddleRight
                        .Columns("z").DefaultCellStyle.Format = "#,##0"
                        .AutoResizeColumns()
                        .FirstDisplayedScrollingRowIndex = _grid1stIndex
                        .ClearSelection()
                    End With
                    btnPrint.Enabled = True
                End If
            End Using

        Catch ex As Exception
            ShowCatchMsg(F_NAME, method, ex)
        End Try
    End Sub

End Class