Imports CKAccount.CC
Imports System.Data.OleDb

Public Class F3100_TBalance

    Const F_NAME As String = "TBalance"

    Private _dt As DataTable
    Private _year As String


    ''' <summary>
    ''' [߂]{^NbNCxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnBack_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles btnBack.Click
        Me.Close()
    End Sub

    ''' <summary>
    ''' [쐬]{^NbNCxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnCreate_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles btnCreate.Click

        Dim msg As String = _year & "Nx̐Z\쐬܂B"
        If MsgCanceled(msg) Then Exit Sub

        If CreateTB() Then
            msg = _year & "Nx̐Z\쐬܂B"
            ShowMsg(msg, MSG_INF)
            UpdateDB = True

            ShowTB()
            btnCreate.Enabled = False
        End If
    End Sub

    ''' <summary>
    ''' [폜]{^NbNCxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnDelete_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles btnDelete.Click

        Dim msg As String = _year & "Nx̐Z\폜܂B"
        If MsgCanceled(msg) Then Exit Sub

        btnDelete.Enabled = False
        'btnPrint.Enabled = False

        If DeleteTable() Then
            msg = _year & "Nx̐Z\폜܂B"
            ShowMsg(msg, MSG_INF)
            UpdateDB = True

            If Not _dt Is Nothing Then
                grdView.DataSource = Nothing
                _dt.Clear()
                _dt = Nothing
            End If
            grdView.Visible = False
            btnCreate.Enabled = True
            lblMsg.Text = "[쐬]{^NbNĂ"
            lblMsg.Visible = True
            btnCreate.Focus()
        End If
    End Sub

    Private Sub btnPrint_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles btnPrint.Click

        ShowMsg("H@", MSG_EXC)
    End Sub

    ''' <summary>
    ''' [cbxYear_KeyDown]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub cbxYear_KeyDown(ByVal sender As System.Object, _
            ByVal e As KeyEventArgs) Handles cbxYear.KeyDown
        CtrlKeyDown(Me, e)
    End Sub

    ''' <summary>
    ''' [cbxYear_SIChanged]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub cbxYear_SIChanged(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles cbxYear.SelectedIndexChanged

        If cbxYear.SelectedIndex < 0 Then Exit Sub

        _year = cbxYear.Text

        lblMsg.Visible = False
        btnDelete.Enabled = False
        'btnPrint.Enabled = False
        btnCreate.Enabled = False
        If Not _dt Is Nothing Then
            grdView.DataSource = Nothing
            _dt.Clear()
            _dt = Nothing
        End If
        grdView.Visible = False

        '*** Nx[T_d]f[^̑݊mF
        If Not CheckJournal() Then
            lblMsg.Text = "Nx̎df[^͓͂Ă܂"
            lblMsg.Visible = True
            btnBack.Focus()
            Exit Sub
        End If

        '*** Nx[T_Z\]f[^̑݊mF
        If Not CheckTB() Then
            btnCreate.Enabled = True
            lblMsg.Text = "[쐬]{^NbNĂ"
            lblMsg.Visible = True
            btnCreate.Focus()

        Else
            ShowTB()
        End If
    End Sub

    ''' <summary>
    ''' [Form_Closing]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Form_Closing(ByVal sender As Object, _
            ByVal e As FormClosingEventArgs) Handles Me.FormClosing

        If Not _dt Is Nothing Then
            grdView.DataSource = Nothing
            _dt.Clear()
            _dt = Nothing
        End If
        F1000_Menu.Show()
    End Sub

    ''' <summary>
    ''' [Form_Load]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Form_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) _
            Handles MyBase.Load

        SetForm(Me)
        FillCbxYear()

        cbxYear.Text = Year(Now).ToString
    End Sub


    ''' <summary>
    ''' [CheckJournal]\bh
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Function CheckJournal() As Boolean

        Dim result As Boolean = False

        Using cn As New OleDbConnection(CnSt)
            Dim sSQL As String = "SELECT ʔ" & _
                                " FROM T_d" & _
                                " WHERE N LIKE @year"
            Using da As New OleDbDataAdapter(sSQL, cn)
                da.SelectCommand.Parameters.AddWithValue("@year", _year & "%")
                Dim dt As New DataTable
                da.Fill(dt)
                If dt.Rows.Count > 0 Then result = True
            End Using
        End Using

        Return result
    End Function

    ''' <summary>
    ''' [CheckTB]\bh
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Function CheckTB() As Boolean

        Dim result As Boolean = False

        Using cn As New OleDbConnection(CnSt)
            Dim sSQL As String = "SELECT ȖC" & _
                                " FROM T_Z\" & _
                                " WHERE Nx = @year"
            Using da As New OleDbDataAdapter(sSQL, cn)
                da.SelectCommand.Parameters.AddWithValue("@year", _year)
                Dim dt As New DataTable
                da.Fill(dt)
                If dt.Rows.Count > 0 Then result = True
            End Using
        End Using

        Return result
    End Function

    ''' <summary>
    ''' [DeleteTable]\bh
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Function DeleteTable() As Boolean

        Dim method As String = New StackFrame(0).GetMethod.Name

        FormDisabled(Me)

        Using cn As New OleDbConnection(CnSt)
            cn.Open()

            Dim tran As OleDbTransaction = cn.BeginTransaction
            Try
                Dim sSQL0 As String = "DELETE FROM T_Z\" & _
                                    " WHERE Nx = @year0"
                Using cmd0 As New OleDbCommand(sSQL0, cn)
                    cmd0.Parameters.AddWithValue("@year0", _year)
                    cmd0.Transaction = tran
                    cmd0.ExecuteNonQuery()
                End Using

                Dim sSQL1 As String = "DELETE FROM T_ݎؑΏƕ\" & _
                                    " WHERE DNo LIKE @year1"
                Using cmd1 As New OleDbCommand(sSQL1, cn)
                    cmd1.Parameters.AddWithValue("@year1", _year & "%")
                    cmd1.Transaction = tran
                    cmd1.ExecuteNonQuery()
                End Using

                Dim sSQL2 As String = "DELETE FROM T_vvZ" & _
                                    " WHERE DNo LIKE @year2"
                Using cmd2 As New OleDbCommand(sSQL2, cn)
                    cmd2.Parameters.AddWithValue("@year2", _year & "%")
                    cmd2.Transaction = tran
                    cmd2.ExecuteNonQuery()
                End Using

                Dim sSQL3 As String = "DELETE FROM T_ʔ" & _
                                    " WHERE DNo LIKE @year3"
                Using cmd3 As New OleDbCommand(sSQL3, cn)
                    cmd3.Parameters.AddWithValue("@year3", _year & "%")
                    cmd3.Transaction = tran
                    cmd3.ExecuteNonQuery()
                End Using

                tran.Commit()
                cn.Close()
                FormEnabled(Me)
                Return True

            Catch ex As Exception
                tran.Rollback()
                cn.Close()
                FormEnabled(Me)
                ShowCatchMsg(F_NAME, method, ex)
                Return False

            End Try
        End Using
    End Function

    ''' <summary>
    ''' [CreateTB]\bh
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Function CreateTB() As Boolean

        Dim method As String = New StackFrame(0).GetMethod.Name

        Dim sday2 As String = _year & "1231"
        Dim i As Integer
        Using cn As New OleDbConnection(CnSt)
            cn.Open()
            Dim code() As String       ' ȖC
            Dim kubun() As String      ' ؑ

            '*** [T_Ȗڃ}X^]ȖځA݂ؑo
            Dim sSQL1 As String = "SELECT ȖC, ؑ" & _
                                " FROM T_Ȗڃ}X^"
            Dim da1 As New OleDbDataAdapter(sSQL1, cn)
            Dim dt1 As New DataTable
            da1.Fill(dt1)
            If dt1.Rows.Count = 0 Then
                cn.Close()
                Return False
            End If
            Dim rowcount As Integer = dt1.Rows.Count
            ReDim code(rowcount - 1)
            ReDim kubun(rowcount - 1)
            For i = 0 To rowcount - 1
                code(i) = dt1.Rows(i).Item("ȖC").ToString
                kubun(i) = dt1.Rows(i).Item("ؑ").ToString
            Next

            Dim dini As Decimal
            Try
                '*** Ȗږ̎cZo  [T_Z\]ւ̏
                For i = 0 To rowcount - 1
                    '*** [T_茳]ɔNf[^}
                    Dim sSQL2 As String = "SELECT z" & _
                                        " FROM T_ݒ" & _
                                        " WHERE ȖC = @code2 AND Nx = @year2"
                    dini = 0
                    Using da2 As New OleDbDataAdapter(sSQL2, cn)
                        da2.SelectCommand.Parameters.AddWithValue("@code2", code(i))
                        da2.SelectCommand.Parameters.AddWithValue("@year2", _year)
                        Dim dt2 As New DataTable
                        da2.Fill(dt2)
                        If dt2.Rows.Count > 0 Then
                            For i2 As Integer = 0 To dt2.Rows.Count - 1
                                dini += Convert.ToDecimal(dt2.Rows(i2)("z"))
                            Next
                        End If
                    End Using

                    Dim sSQL3 As String = "DELETE FROM T_茳"
                    Using cmd3 As New OleDbCommand(sSQL3, cn)
                        cmd3.ExecuteNonQuery()
                    End Using

                    Dim sday1 As String = _year & "0101"
                    Dim sSQL4 As String = _
                            "INSERT INTO T_茳 (ʔ, N, c) " & _
                            "VALUES ('', @day14, @dini4)"
                    Using cmd4 As New OleDbCommand(sSQL4, cn)
                        cmd4.Parameters.AddWithValue("@day14", sday1)
                        cmd4.Parameters.AddWithValue("@dini4", dini)
                        cmd4.ExecuteNonQuery()
                    End Using

                    '*** [T_茳]Ɏؕf[^}
                    Dim sSQL5 As String = _
                        "INSERT INTO T_茳 (ʔ, N, ؕ, ȖC, Ev)" & _
                        " SELECT ʔ, N, z, ݕC, Ev" & _
                            " FROM T_d" & _
                            " WHERE ؕC = @code5 AND N LIKE @year5"
                    Using cmd5 As New OleDbCommand(sSQL5, cn)
                        cmd5.Parameters.AddWithValue("@code5", code(i))
                        cmd5.Parameters.AddWithValue("@year5", _year & "%")
                        cmd5.ExecuteNonQuery()
                    End Using

                    '*** [T_茳]ɑݕf[^}
                    Dim sSQL6 As String = _
                        "INSERT INTO T_茳 (ʔ, N, ݕ, ȖC, Ev)" & _
                        " SELECT ʔ, N, z, ؕC, Ev" & _
                            " FROM T_d" & _
                            " WHERE ݕC = @code6 AND N LIKE @year6"
                    Using cmd6 As New OleDbCommand(sSQL6, cn)
                        cmd6.Parameters.AddWithValue("@code6", code(i))
                        cmd6.Parameters.AddWithValue("@year6", _year & "%")
                        cmd6.ExecuteNonQuery()
                    End Using

                    '*** c̎Zo
                    Dim dzan As Decimal
                    Dim sSQL7 As String = "SELECT ؕ, ݕ, c" & _
                                        " FROM T_茳" & _
                                        " ORDER BY N, ʔ"
                    Using da7 As New OleDbDataAdapter(sSQL7, cn)
                        Dim dt7 As New DataTable
                        da7.Fill(dt7)

                        dzan = Convert.ToDecimal(dt7.Rows(0).Item("c"))

                        For i7 As Integer = 1 To dt7.Rows.Count - 1
                            Dim debtor As Decimal = 0
                            If Not DBNull.Value.Equals(dt7.Rows(i7).Item("ؕ")) Then
                                debtor = Convert.ToDecimal(dt7.Rows(i7).Item("ؕ"))
                            End If
                            Dim creditor As Decimal = 0
                            If Not DBNull.Value.Equals(dt7.Rows(i7).Item("ݕ")) Then
                                creditor = Convert.ToDecimal(dt7.Rows(i7).Item("ݕ"))
                            End If

                            If kubun(i) = "" Then
                                dzan += debtor - creditor
                            Else
                                dzan += creditor - debtor
                            End If
                        Next
                    End Using

                    Dim sSQL8 As String = _
                            "INSERT INTO T_Z\ (Nx, ȖC, z)" & _
                            " VALUES (@year8, @code8, @dzan8)"
                    Using cmd8 As New OleDbCommand(sSQL8, cn)
                        cmd8.Parameters.AddWithValue("@year8", _year)
                        cmd8.Parameters.AddWithValue("@code8", code(i))
                        cmd8.Parameters.AddWithValue("@dzan8", dzan)
                        cmd8.ExecuteNonQuery()
                    End Using
                Next i

                Return True

            Catch ex As Exception
                ShowCatchMsg(F_NAME, method, ex)
                Return False

            End Try
        End Using
    End Function

    ''' <summary>
    ''' [FillCbxYear]\bh
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub FillCbxYear()

        For i As Integer = MinYear To MaxYear
            cbxYear.Items.Add(i.ToString)
        Next
    End Sub

    ''' <summary>
    ''' [ShowTB]\bh
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub ShowTB()

        Using cn As New OleDbConnection(CnSt)
            Dim sSQL As String = "SELECT Ȗ, z" & _
                                " FROM V_Z\" & _
                                " WHERE Nx = @year" & _
                                " ORDER BY ȖC"
            Using da As New OleDbDataAdapter(sSQL, cn)
                da.SelectCommand.Parameters.AddWithValue("@year", _year)
                _dt = New DataTable
                da.Fill(_dt)

                If _dt.Rows.Count = 0 Then
                    grdView.Visible = False
                    'lblMsg.Visible = True

                Else
                    lblMsg.Visible = False
                    With grdView
                        .DataSource = _dt
                        .Visible = True
                        .Columns("z").DefaultCellStyle.Alignment = _
                                DataGridViewContentAlignment.MiddleRight
                        .Columns("z").DefaultCellStyle.Format = "#,##0"
                        SetGridProperty(grdView)
                        .AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.AllCells
                        .AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.None
                        .Columns("z").Width = 110
                    End With

                    'btnPrint.Enabled = True
                    btnDelete.Enabled = True
                    'btnPrint.Focus()
                End If
            End Using
        End Using
    End Sub

End Class