Imports CKAccount.CC
Imports System.Data.OleDb

Public Class F2010_AccountMaster

    Const F_NAME As String = "AccountMaster"

    Const DECR_CREDITOR As String = ""
    Const DECR_DEBTOR As String = ""
    Const TYPE_ASSET As String = "Y"
    Const TYPE_CAPITAL As String = "{"
    Const TYPE_DEBT As String = ""
    Const TYPE_EXPENSE As String = "o"
    Const TYPE_INCOME As String = ""

    Private _gridClicked As Boolean
    Private _dt As DataTable

    ''' <summary>
    ''' [ǉ]{^NbNCxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnAdd_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles btnAdd.Click

        Dim method As String = New StackFrame(0).GetMethod.Name

        '*** ͒l̊mF
        If Not CheckInputValue() Then Exit Sub

        '*** ͒lϐ֑
        Dim code As String = txtCode.Text.Trim
        Dim sname As String = txtAccount.Text.Trim
        If NGetByteCount(sname) > 16 Then
            sname = NLeftB(sname, 16, False)
        End If
        Dim type As String = cbxType.Text
        Dim decr As String = GetDeCr(type)

        '*** o^ۂ̊mF
        Dim msg As String = "ȖڃR[h [" & code & "] ǉo^܂B"
        If MsgCanceled(msg) Then
            txtCode.Focus()
            Exit Sub
        End If

        '*** o^̎s
        Using cn As New OleDbConnection(CnSt)
            cn.Open()

            Dim sSQL As String = "INSERT INTO T_Ȗڃ}X^" & _
                    " (ȖC, Ȗ, , ؑ, Special) " & _
                "VALUES (@code, @name, @type, @decr, '')"

            Using cmd As New OleDbCommand(sSQL, cn)
                Try
                    cmd.Parameters.AddWithValue("@code", code)
                    cmd.Parameters.AddWithValue("@name", sname)
                    cmd.Parameters.AddWithValue("@type", type)
                    cmd.Parameters.AddWithValue("@decr", decr)
                    cmd.ExecuteNonQuery()

                    '*** IbZ[W
                    ShowMsg("o^I܂B", MSG_INF)
                    UpdateDB = True

                    '*** DG̕\XV
                    ShowGrid()

                    SetFocus2Grid()
                    btnAlter.Enabled = True
                    btnDelete.Enabled = True
                    btnUpdate.Enabled = True
                    btnAdd.Enabled = False
                    txtCode.Focus()

                Catch ex As Exception
                    ShowCatchMsg(F_NAME, method, ex)
                    txtCode.Focus()

                End Try
            End Using

            cn.Close()
        End Using
    End Sub

    ''' <summary>
    ''' [R[hύX]{^NbNCxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnAlter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
            Handles btnAlter.Click

        '*** [F2014_ACodeAlter][_ŕ\
        Using oform As New F2014_ACodeAlter
            With oform
                .ParentLeft = Me.Left
                .ParentTop = Me.Top
                .Code = txtCode.Text
                .Name2014 = txtAccount.Text
                .ShowDialog()

                '*** txtCodeNAāAgrdAccount̕\XV
                Dim code As String = .Code
                If code.Length > 0 Then
                    ShowGrid()
                    txtCode.Text = code
                End If
            End With
        End Using

        txtCode.Focus()
    End Sub

    ''' <summary>
    ''' [߂]{^NbNCxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnBack_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles btnBack.Click
        Me.Close()
    End Sub

    ''' <summary>
    ''' [NA]{^NbNCxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
            Handles btnClear.Click

        txtCode.Text = String.Empty
        txtAccount.Text = String.Empty
        cbxType.SelectedIndex = -1

        grdView.ClearSelection()
        txtCode.Focus()
    End Sub

    ''' <summary>
    ''' [폜]{^NbNCxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnDelete_Click(ByVal sender As System.Object, _
             ByVal e As System.EventArgs) Handles btnDelete.Click

        Dim method As String = New StackFrame(0).GetMethod.Name

        Dim code As String = txtCode.Text.Trim

        Dim msg As String
        '*** 폜ۂ̊mF
        If IsSpecialCode(code) Then
            msg = "̃R[h͓̖ړIɎg邽߁A폜ł܂B"
            ShowMsg(msg, MSG_EXC)
            Exit Sub
        End If

        If Not DeleteCheck(code) Then
            txtCode.Focus()
            txtCode.SelectAll()
            Exit Sub
        End If

        '*** 폜̎s
        Using cn As New OleDbConnection(CnSt)
            cn.Open()
            Dim sSQL As String = "DELETE FROM T_Ȗڃ}X^ " & _
                                " WHERE ȖC = @code"
            Try
                Using cmd As New OleDbCommand(sSQL, cn)
                    cmd.Parameters.AddWithValue("@code", code)
                    cmd.ExecuteNonQuery()

                    '*** IbZ[W
                    ShowMsg("폜I܂B", MSG_INF)
                    UpdateDB = True

                    '*** DG̕\XV
                    ShowGrid()

                    txtCode.Text = String.Empty
                    txtCode.Focus()
                End Using

            Catch ex As Exception
                ShowCatchMsg(F_NAME, method, ex)
            End Try

            cn.Close()
        End Using
    End Sub

    ''' <summary>
    ''' []{^NbNCxg...H
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnPrint_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
            Handles btnPrint.Click
        ShowMsg("H@", MSG_EXC)
    End Sub

    ''' <summary>
    ''' [C]{^NbNCxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnUpdate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
            Handles btnUpdate.Click

        Dim method As String = New StackFrame(0).GetMethod.Name

        '*** ͒l̊mFAϐւ̑
        If Not CheckInputValue() Then Exit Sub

        '*** ͒lϐ֑
        Dim code As String = txtCode.Text.Trim
        Dim sname As String = txtAccount.Text.Trim
        If NGetByteCount(sname) > 16 Then
            sname = NLeftB(sname, 16, False)
        End If
        Dim type As String = cbxType.Text
        Dim decr As String = GetDeCr(type)

        '*** Cۂ̊mF
        Dim msg As String = "ȖڃR[h [" & code & "] Co^܂B"
        If MsgCanceled(msg) Then
            txtCode.Focus()
            Exit Sub
        End If

        '*** o^̎s
        Using cn As New OleDbConnection(CnSt)
            cn.Open()
            Dim sSQL As String = "UPDATE T_Ȗڃ}X^" & _
                " SET Ȗ = @name," & _
                    "  = @type," & _
                    " ؑ = @decr" & _
                " WHERE ȖC = @code"

            Using cmd As New OleDbCommand(sSQL, cn)
                Try
                    cmd.Parameters.AddWithValue("@name", sname)
                    cmd.Parameters.AddWithValue("@type", type)
                    cmd.Parameters.AddWithValue("@decr", decr)
                    cmd.Parameters.AddWithValue("@code", code)
                    cmd.ExecuteNonQuery()

                    '*** IbZ[W
                    ShowMsg("o^I܂B", MSG_INF)
                    UpdateDB = True

                    '*** DG̕\XV
                    ShowGrid()

                    SetFocus2Grid()
                    txtCode.Focus()

                Catch ex As Exception
                    ShowCatchMsg(F_NAME, method, ex)
                    txtCode.Focus()

                End Try
            End Using

            cn.Close()
        End Using
    End Sub

    ''' <summary>
    ''' [cbxType_KeyDown]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub cbxType_KeyDown(ByVal sender As System.Object, ByVal e As KeyEventArgs) _
            Handles cbxType.KeyDown
        CtrlKeyDown(Me, e)
    End Sub

    ''' <summary>
    ''' [Form_Closing]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Form_Closing(ByVal sender As System.Object, _
            ByVal e As FormClosingEventArgs) Handles Me.FormClosing

        If Not _dt Is Nothing Then
            grdView.DataSource = Nothing
            _dt.Clear()
            _dt = Nothing
        End If
        F1000_Menu.Show()
    End Sub

    ''' <summary>
    ''' [Form_Load]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Form_Load(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles MyBase.Load

        SetForm(Me)
        _gridClicked = False

        '*** ComboBox̐ݒ
        FillCbxType()
        txtCode.MaxLength = CodeLenAccount

        ShowGrid()
        SetGridProperty(grdView)
        txtCode.Text = String.Empty
    End Sub

    ''' <summary>
    ''' [grdView_Click]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub grdView_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles grdView.Click

        _gridClicked = True
        With grdView
            If .SelectedRows.Count = 0 Then
                .Rows(0).Selected = True
                txtCode.Text = .Rows(0).Cells("ȖC").Value.ToString
            Else
                txtCode.Text = .Rows(.CurrentRow.Index).Cells("ȖC").Value.ToString
            End If
        End With

        txtCode.Focus()
    End Sub

    ''' <summary>
    ''' [TB_Enter]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub TB_Enter(ByVal sender As System.Object, ByVal e As System.EventArgs) _
            Handles txtCode.Enter, txtAccount.Enter

        CType(sender, TextBox).SelectAll()
    End Sub

    ''' <summary>
    ''' [TB_KeyDown]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub TB_KeyDown(ByVal sender As System.Object, ByVal e As KeyEventArgs) _
            Handles txtCode.KeyDown, txtAccount.KeyDown

        CtrlKeyDown(Me, e)
    End Sub

    ''' <summary>
    ''' [txtCode_TextChanged]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub txtCode_TextChanged(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles txtCode.TextChanged

        Dim method As String = New StackFrame(0).GetMethod.Name

        txtAccount.Text = String.Empty
        btnAlter.Enabled = False
        btnDelete.Enabled = False
        btnAdd.Enabled = False
        btnUpdate.Enabled = False
        cbxType.SelectedIndex = -1
        If Not _gridClicked Then
            grdView.ClearSelection()
        End If

        Dim code As String = txtCode.Text.Trim
        If code.Length < CodeLenAccount Then Exit Sub

        Try
            Using cn As New OleDbConnection(CnSt)
                Dim sSQL As String = "SELECT Ȗ, " & _
                                    " FROM T_Ȗڃ}X^" & _
                                    " WHERE ȖC = @code"
                Using da As New OleDbDataAdapter(sSQL, cn)
                    da.SelectCommand.Parameters.AddWithValue("@code", code)
                    Dim dt As New DataTable
                    da.Fill(dt)
                    If dt.Rows.Count > 0 Then
                        txtAccount.Text = dt.Rows(0)("Ȗ").ToString
                        cbxType.Text = dt.Rows(0)("").ToString
                        btnAlter.Enabled = True
                        btnDelete.Enabled = True
                        btnUpdate.Enabled = True

                        If _gridClicked Then
                            _gridClicked = False
                        Else
                            '*** GridClickɂ̂łȂƂɂ́AGrid̊YsI
                            SetFocus2Grid()
                        End If
                    Else
                        grdView.ClearSelection()
                        btnAdd.Enabled = True
                    End If
                End Using
            End Using

        Catch ex As Exception
            ShowCatchMsg(F_NAME, method, ex)

        End Try
    End Sub

    ''' <summary>
    ''' [txtCode_Validating]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub txtCode_Validating(ByVal sender As System.Object, _
            ByVal e As System.ComponentModel.CancelEventArgs) Handles txtCode.Validating

        If ActiveControl Is btnBack Then Exit Sub

        Dim code As String = txtCode.Text.Trim
        If code.Length = 0 Then Exit Sub

        If Not IsDigit(code) Or code.Length <> CodeLenAccount Then
            Dim msg As String = "ȖڃR[h́A" & CodeLenAccount.ToString _
                    & "̐œ͂ĂB"
            ShowMsg(msg, MSG_EXC)
            e.Cancel = True
        End If
    End Sub


    ''' <summary>
    ''' [CheckInputValue]\bh
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Function CheckInputValue() As Boolean

        Dim result As Boolean = False
        Dim msg As String = String.Empty
        '*** ͒l̊mFAϐւ̑
        Dim code As String = txtCode.Text.Trim
        Dim sname As String = txtAccount.Text.Trim
        If Not IsDigit(code) Or code.Length <> CodeLenAccount Then
            msg = "ȖڃR[h́A" & CodeLenAccount.ToString & "̐œ͂ĂB"
            ShowMsg(msg, MSG_EXC)
            txtCode.Focus()

        ElseIf sname = String.Empty Then
            msg = "Ȗڂ͂ĂB"
            ShowMsg(msg, MSG_EXC)
            txtAccount.Focus()

        ElseIf cbxType.Text = String.Empty Then
            msg = "ނ͂ĂB"
            ShowMsg(msg, MSG_EXC)
            cbxType.Focus()

        Else
            result = True
        End If

        Return result
    End Function

    ''' <summary>
    ''' [DeleteCheck]\bh
    ''' </summary>
    ''' <param name="vcode"></param>
    ''' <returns>True:폜AFalse:폜sԂ</returns>
    ''' <remarks>[btnDelete_Click]ďo</remarks>
    Private Function DeleteCheck(ByVal vcode As String) As Boolean

        Dim ydata As New List(Of String)
        Using cn As New OleDbConnection(CnSt)
            Dim sSQL As String = "SELECT LEFT(N, 4) AS N, COUNT(ʔ) AS " & _
                                " FROM T_d" & _
                                " WHERE ؕC = @code OR ݕC = @code" & _
                                " GROUP BY LEFT(N, 4)" & _
                                " ORDER BY LEFT(N, 4)"
            Using da As New OleDbDataAdapter(sSQL, cn)
                da.SelectCommand.Parameters.AddWithValue("@code", vcode)
                Dim dt As New DataTable
                da.Fill(dt)
                If dt.Rows.Count > 0 Then
                    Dim syear As String = String.Empty
                    Dim count As String = String.Empty
                    For i1 As Integer = 0 To dt.Rows.Count - 1
                        syear = dt.Rows(i1)("N").ToString & "N  "
                        count = dt.Rows(i1)("").ToString
                        ydata.Add(syear & count & "")
                    Next
                End If
            End Using
        End Using

        Dim msg As String = String.Empty
        If ydata.Count > 0 Then
            msg = "R[h[" & vcode & "]ɂ́AߋɈȉ̎df[^݂邽߁A" & _
                "폜͂ł܂B" & vbNewLine
            For i2 As Integer = 0 To ydata.Count - 1
                msg &= vbNewLine & Space(8) & ydata(i2)
            Next
            ShowMsg(msg, MSG_EXC)
            Return False

        Else
            msg = "R[h [" & vcode & "] 폜܂B"
            Return Not MsgCanceled(msg)
        End If
    End Function

    ''' <summary>
    ''' [GetDeCr]\bh
    ''' </summary>
    ''' <param name="vtype"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Function GetDeCr(ByVal vtype As String) As String

        Dim result As String = DECR_CREDITOR
        If vtype = TYPE_ASSET Or vtype = TYPE_EXPENSE Then
            result = DECR_DEBTOR
        End If

        Return result
    End Function

    ''' <summary>
    ''' [IsSpecialCode]\bh
    ''' </summary>
    ''' <param name="vcode"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Function IsSpecialCode(ByVal vcode As String) As Boolean

        If vcode = AcCodeCash Then Return True
        If vcode = AcCodeCommute Then Return True
        If vcode = AcCodeProfitPY Then Return True
        If vcode = AcCodeSales Then Return True
        If vcode = AcCodeShokuti Then Return True

        Return False
    End Function

    ''' <summary>
    ''' [FillCbxType]\bh
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub FillCbxType()
        cbxType.Items.Add(TYPE_ASSET)
        cbxType.Items.Add(TYPE_DEBT)
        cbxType.Items.Add(TYPE_CAPITAL)
        cbxType.Items.Add(TYPE_INCOME)
        cbxType.Items.Add(TYPE_EXPENSE)
    End Sub

    ''' <summary>
    ''' [SetFocus2Grid]\bh
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub SetFocus2Grid()

        Dim code As String = txtCode.Text
        With grdView
            Dim i As Integer
            For i = 0 To .Rows.Count - 1
                If code = .Rows(i).Cells("ȖC").Value.ToString Then
                    .Rows(i).Selected = True
                    Exit For
                End If
            Next
            If i < .Rows.Count Then
                .FirstDisplayedScrollingRowIndex = i
            End If
        End With
    End Sub

    ''' <summary>
    ''' [ShowGrid]\bh
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub ShowGrid()

        Dim method As String = New StackFrame(0).GetMethod.Name

        If Not _dt Is Nothing Then
            _dt.Clear()
            grdView.DataSource = Nothing
        End If

        Dim sSQL As String = "SELECT ȖC, Ȗ, " & _
                            " FROM T_Ȗڃ}X^" & _
                            " ORDER BY ȖC"
        Try
            Using cn As New OleDbConnection(CnSt)
                Dim da As New OleDbDataAdapter(sSQL, cn)
                _dt = New DataTable()
                da.Fill(_dt)

                If _dt.Rows.Count = 0 Then
                    grdView.Visible = False

                Else
                    With grdView
                        .Visible = True
                        .DataSource = _dt
                        .Columns("ȖC").Width = 60
                        .Columns("Ȗ").Width = 150
                        .Columns("").Width = 60
                        .ClearSelection()
                    End With
                End If
            End Using

        Catch ex As Exception
            ShowCatchMsg(F_NAME, method, ex)
        End Try
    End Sub

End Class