Imports CKAccount.CC
Imports System.Data.OleDb

Public Class F3010_Journal

    Const TABLE_NAME As String = "F3010_DT"
    Const F_NAME As String = "Journal"

    Private _cbxdeidx As Integer = 0         ' O̒ǉ̉Ȗڂۑ邽߂Ɏgp
    Private _cbxcridx As Integer = 0         ' O̒ǉ̉Ȗڂۑ邽߂Ɏgp
    Private _dt As DataTable
    Private _lYearWork As Boolean = False    ' TrueF[lblYear_TextChanged]Lɓ삳
    Private _toCommute As Boolean = False
    Private _ymd As String              ' ƔN(Y4M2D2) [dtpJournal_ValueChanged]Ŏ擾 

    ''' <summary>
    ''' [ǉ]{^NbNCxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnAdd_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles btnAdd.Click

        Dim method As String = New StackFrame(0).GetMethod.Name

        '*** ̓f[^̃`FbN
        If Not CheckInput() Then Exit Sub

        Dim debtor As String = cbxDebtor.Text.Substring(0, CodeLenAccount)
        Dim creditor As String = cbxCreditor.Text.Substring(0, CodeLenAccount)
        Dim dyen As Decimal = Convert.ToDecimal(txtYen.Text.Replace(",", "").Trim)
        Dim complement As String = txtComplement.Text.Trim
        If NGetByteCount(complement) > 30 Then
            complement = NLeftB(complement, 30, False)
        End If

        '*** itemnum̎擾
        Dim itemnum As String = GetMaxNum()
        If itemnum.Length = 0 Then Exit Sub

        '*** df[^o^
        If Not InsertData(False, itemnum, debtor, creditor, dyen, complement) Then Exit Sub

        ShowMsg("ǉIB", MSG_INF)
        UpdateDB = True

        _cbxdeidx = cbxDebtor.SelectedIndex
        _cbxcridx = cbxCreditor.SelectedIndex

        ShowGrid()
        cbxDebtor.SelectedIndex = -1
        cbxCreditor.SelectedIndex = -1
        txtYen.Text = String.Empty
        txtComplement.Text = String.Empty
        grdView.FirstDisplayedScrollingRowIndex = grdView.RowCount - 1
        dtpJournal.Focus()
    End Sub

    ''' <summary>
    ''' [߂]{^NbNCxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnBack_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles btnBack.Click

        _toCommute = False
        Me.Close()
    End Sub

    ''' <summary>
    ''' [NA]{^NbNCxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnClear_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles btnClear.Click

        ClearData()
    End Sub

    ''' <summary>
    ''' [폜]{^NbNCxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnDelete_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles btnDelete.Click

        Dim method As String = New StackFrame(0).GetMethod.Name
        Dim msg As String = String.Empty

        '*** 폜ۂ̊mF
        If MsgCanceled("\Ăd폜܂B") Then
            cbxDebtor.Focus()
            Exit Sub
        End If

        '*** ʂ𖳌
        FormDisabled(Me)
        Dim itemnum As String = lblItemNo.Text

        '*** 폜̎s
        Try
            Using cn As New OleDbConnection(CnSt)
                cn.Open()
                Dim sSQL As String = "DELETE FROM T_d" & _
                                    " WHERE ʔ = @itemnum"
                Using cmd As New OleDbCommand(sSQL, cn)
                    cmd.Parameters.AddWithValue("@itemnum", itemnum)
                    cmd.ExecuteNonQuery()
                End Using

                '*** ʂLɖ߂
                FormEnabled(Me)

                '*** IbZ[W
                ShowMsg("폜I܂B", MSG_INF)
                UpdateDB = True

                '*** DG̕\XV
                ShowGrid()
                ClearData()
            End Using

        Catch ex As Exception
            '*** ʂLɖ߂
            FormEnabled(Me)

            ShowCatchMsg(F_NAME, method, ex)
        End Try
    End Sub

    ''' <summary>
    ''' []{^NbNCxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnPrint_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles btnPrint.Click

        Dim syear As String = lblYear.Text
        Dim term As String = syear & "N11`" & syear & "N1231"

        FormDisabled(Me)
        PrintTable(_dt, term)
        FormEnabled(Me)
    End Sub

    ''' <summary>
    ''' [ʔ]{^NbNCxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnToCommute_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles btnToCommute.Click

        _toCommute = True
        Me.Close()
    End Sub

    ''' <summary>
    ''' [C]{^NbNCxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnUpdate_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles btnUpdate.Click

        '*** ̓f[^̃`FbN
        If Not CheckInput() Then Exit Sub

        '*** o^ۂ̊mF
        If MsgCanceled("dCo^܂B") Then
            cbxDebtor.Focus()
            Exit Sub
        End If

        Dim itemnum As String = lblItemNo.Text
        Dim debtor As String = cbxDebtor.Text.Substring(0, CodeLenAccount)
        Dim creditor As String = cbxCreditor.Text.Substring(0, CodeLenAccount)
        Dim dyen As Decimal = Convert.ToDecimal(txtYen.Text.Replace(",", "").Trim)
        Dim complement As String = txtComplement.Text.Trim
        If NGetByteCount(complement) > 30 Then
            complement = NLeftB(complement, 30, False)
        End If
        
        '*** df[^o^
        If Not InsertData(True, itemnum, debtor, creditor, dyen, complement) Then Exit Sub

        ShowMsg("CIB", MSG_INF)
        UpdateDB = True

        ShowGrid()
        SetGridScroll(lblItemNo.Text)
    End Sub

    ''' <summary>
    ''' [cbxCreditor_Enter]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>O̒ǉ̉Ȗڂۑ邽߂Ɏgp</remarks>
    Private Sub cbxCreditor_Enter(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles cbxCreditor.Enter
        cbxCreditor.SelectedIndex = _cbxcridx
    End Sub

    ''' <summary>
    ''' [cbxDebtor_Enter]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>O̒ǉ̉Ȗڂۑ邽߂Ɏgp</remarks>
    Private Sub cbxDebtor_Enter(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles cbxDebtor.Enter
        cbxDebtor.SelectedIndex = _cbxdeidx
    End Sub

    ''' <summary>
    ''' [(e)Ctrls_KeyDown]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Ctrls_KeyDown(ByVal sender As System.Object, ByVal e As KeyEventArgs) Handles _
            dtpJournal.KeyDown, txtYen.KeyDown, txtComplement.KeyDown, _
            cbxDebtor.KeyDown, cbxCreditor.KeyDown
        CtrlKeyDown(Me, e)
    End Sub

    ''' <summary>
    ''' [dtpJournal_ValueChanged]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub dtpJournal_ValueChanged(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles dtpJournal.ValueChanged

        Dim ddate As Date = dtpJournal.Value
        _ymd = Date2Ymd(ddate)

        lblYear.Text = ddate.Year.ToString   ' ̓[ShowGrid]쓮
    End Sub

    ''' <summary>
    ''' [Form_Closing]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Form_Closing(ByVal sender As System.Object, _
            ByVal e As FormClosingEventArgs) Handles MyBase.FormClosing

        If Not _dt Is Nothing Then
            grdView.DataSource = Nothing
            _dt.Clear()
            _dt = Nothing
        End If
        If _toCommute Then
            F3020_Commute.Show()
        Else
            F1000_Menu.Show()
        End If
    End Sub

    ''' <summary>
    ''' [Form_Load]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Form_Load(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles MyBase.Load
        SetForm(Me)
        InitializeForm()
    End Sub

    ''' <summary>
    ''' [grdView_Click]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub grdView_Click(ByVal sender As Object, _
            ByVal e As System.EventArgs) Handles grdView.Click

        With grdView
            If .SelectedRows.Count > 0 Then
                Dim index As Integer = .CurrentRow.Index
                Dim ymd As String = .Rows(index).Cells("N").Value.ToString
                Try
                    dtpJournal.Value = Ymd2Date(ymd)
                Catch ex As Exception
                    ShowMsg("NsK؂łB", MSG_EXC)
                    Exit Sub
                End Try

                lblItemNo.Text = .Rows(index).Cells("ʔ").Value.ToString
                Dim dcode As String = .Rows(index).Cells("ؕC").Value.ToString
                Dim daccount As String = .Rows(index).Cells("ؕ").Value.ToString
                cbxDebtor.Text = dcode & ") " & daccount
                _cbxdeidx = cbxDebtor.SelectedIndex

                Dim ccode As String = .Rows(index).Cells("ݕC").Value.ToString
                Dim caccount As String = .Rows(index).Cells("ݕ").Value.ToString
                cbxCreditor.Text = ccode & ") " & caccount
                _cbxcridx = cbxCreditor.SelectedIndex

                txtYen.Text = Convert.ToInt32(.Rows(index).Cells("z").Value).ToString("#,##0")
                txtComplement.Text = .Rows(index).Cells("Ev").Value.ToString
            End If
        End With

        cbxDebtor.Focus()
    End Sub

    ''' <summary>
    ''' [lblItemNo_TextChanged]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub lblItemNo_TextChanged(ByVal sender As Object, _
            ByVal e As System.EventArgs) Handles lblItemNo.TextChanged

        If lblItemNo.Text.Length = 0 Then
            'rdoAdd.Enabled = True
            'rdoAdd.Checked = True
            rdoUpdate.Enabled = False
            rdoDelete.Enabled = False
        Else
            'rdoAdd.Enabled = False
            rdoUpdate.Enabled = True
            rdoUpdate.Checked = True
            rdoDelete.Enabled = True
        End If
    End Sub

    ''' <summary>
    ''' [lblYear_TextChanged]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub lblYear_TextChanged(ByVal sender As Object, _
            ByVal e As System.EventArgs) Handles lblYear.TextChanged

        If Not _lYearWork Then
            _lYearWork = True
            Exit Sub
        End If

        ShowGrid()
        If grdView.Rows.Count > 0 Then
            grdView.FirstDisplayedScrollingRowIndex = grdView.Rows.Count - 1
        End If
    End Sub

    ''' <summary>
    ''' [RdoBtn_CheckedChanged]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub RdoBtn_CheckedChanged(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles _
            rdoUpdate.CheckedChanged, rdoAdd.CheckedChanged, rdoDelete.CheckedChanged

        If Not CType(sender, RadioButton).Checked Then Exit Sub

        If sender Is rdoAdd Then
            '*** [ǉ]{^Checked̏ꍇ
            grdView.ClearSelection()
            btnAdd.Enabled = True
            btnUpdate.Enabled = False
            btnDelete.Enabled = False
            lblItemNo.Text = String.Empty
            btnAdd.Focus()

        ElseIf sender Is rdoUpdate Then
            '*** [C]{^Checked̏ꍇ
            btnAdd.Enabled = False
            btnUpdate.Enabled = True
            btnDelete.Enabled = False
            btnUpdate.Focus()

        Else
            '*** [폜]{^Checked̏ꍇ
            btnAdd.Enabled = False
            btnUpdate.Enabled = False
            btnDelete.Enabled = True
            btnDelete.Focus()

        End If
    End Sub

    ''' <summary>
    ''' [TB_Enter]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub TB_Enter(ByVal sender As System.Object, ByVal e As System.EventArgs) _
            Handles txtComplement.Enter, txtYen.Enter

        CType(sender, TextBox).SelectAll()
    End Sub

    ''' <summary>
    ''' [txtComplement_Validating]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub txtComplement_Validating(ByVal sender As Object, _
            ByVal e As System.ComponentModel.CancelEventArgs) Handles txtComplement.Validating
        RemoveNewLine(txtComplement)
    End Sub

    ''' <summary>
    ''' [txtYen_Validating]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub txtYen_Validating(ByVal sender As Object, _
            ByVal e As System.ComponentModel.CancelEventArgs) Handles txtYen.Validating

        If ActiveControl Is btnBack Then Exit Sub

        ValidateTBYen(txtYen)
    End Sub


    ''' <summary>
    ''' [CheckInput]\bh
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Function CheckInput() As Boolean

        Dim msg As String = String.Empty
        '*** ͒l̊mFAϐւ̑
        Dim syen As String = txtYen.Text.Trim
        If syen.Length > 0 AndAlso syen.Substring(0, 1) = "-" Then
            syen = syen.Substring(1)
        End If
        syen = syen.Replace(",", "")

        If cbxDebtor.SelectedIndex < 0 Then
            ShowMsg("ؕ󗓂łB", MSG_EXC)
            cbxDebtor.Focus()
            Return False

        ElseIf cbxCreditor.SelectedIndex < 0 Then
            ShowMsg("ݕ󗓂łB", MSG_EXC)
            cbxCreditor.Focus()
            Return False
        End If

        If Not IsDigit(syen) Then
            ShowMsg("z𐮐œ͂ĂB", MSG_EXC)
            txtYen.Focus()
            txtYen.SelectAll()
            Return False
        End If

        Return True
    End Function

    ''' <summary>
    ''' [GetMaxNum]\bhFgpʔԂԂ
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks>[btnAdd_Click],[InsertData]Ŏgp</remarks>
    Private Function GetMaxNum() As String

        Dim method As String = New StackFrame(0).GetMethod.Name

        Dim itemnum As String = String.Empty
        Try
            Using cn As New OleDbConnection(CnSt)
                Dim syear As String = lblYear.Text
                Dim sSQL As String = "SELECT MAX(ʔ) AS MaxNo" & _
                                    " FROM T_d" & _
                                    " WHERE N LIKE @year"

                Using da As New OleDbDataAdapter(sSQL, cn)
                    da.SelectCommand.Parameters.AddWithValue("@year", syear & "%")
                    Dim dt As New DataTable
                    da.Fill(dt)

                    If dt.Rows.Count > 0 Then
                        itemnum = dt.Rows(0).Item("MaxNo").ToString
                    End If
                    If itemnum.Length = 0 Then
                        itemnum = syear & PadLeft0("1", ITEMNUM_FIG)
                    Else
                        Dim inum As Integer = Int32.Parse(itemnum) + 1
                        itemnum = inum.ToString
                    End If
                End Using
            End Using
            If itemnum.Length > "2000".Length + ITEMNUM_FIG Then
                ShowMsg("ʔԂ̌I[o[t[܂B", MSG_EXC)
                itemnum = String.Empty
            End If

        Catch ex As Exception
            ShowCatchMsg(F_NAME, method, ex)
            itemnum = String.Empty
        End Try

        Return itemnum
    End Function

    ''' <summary>
    ''' [InsertData]\bh
    ''' </summary>
    ''' <param name="vUpdate"></param>
    ''' <param name="vitemnum"></param>
    ''' <param name="vdebtor"></param>
    ''' <param name="vcreditor"></param>
    ''' <param name="vyen"></param>
    ''' <param name="vcomplement"></param>
    ''' <returns></returns>
    ''' <remarks>[btnAdd_Click],[btnUpdate_Click]ďo</remarks>
    Private Function InsertData(ByVal vUpdate As Boolean, _
                                ByVal vitemnum As String, _
                                ByVal vdebtor As String, _
                                ByVal vcreditor As String, _
                                ByVal vyen As Decimal, _
                                ByVal vcomplement As String) As Boolean

        Const DECR_DE As Integer = 1
        Const DECR_CR As Integer = -1

        Dim method As String = New StackFrame(0).GetMethod.Name
        Dim itemnum As String = vitemnum
        FormDisabled(Me)

        Using cn As New OleDbConnection(CnSt)
            cn.Open()

            Dim tran As OleDbTransaction = cn.BeginTransaction
            Try
                If vUpdate Then
                    '*** C̏ꍇɂ́Ad󒠂̊YʔԂ̃R[h폜
                    Dim sSQL1 As String = "DELETE FROM T_d" & _
                                        " WHERE ʔ = " & ApoStr(itemnum)
                    Using cmd1 As New OleDbCommand(sSQL1, cn)
                        cmd1.Transaction = tran
                        cmd1.ExecuteNonQuery()
                    End Using

                    Dim year1 As String = _ymd.Substring(0, 4)
                    Dim year2 As String = itemnum.Substring(0, 4)
                    '*** قȂNxɏCꍇ̏
                    If year1 <> year2 Then
                        itemnum = GetMaxNum()
                        If itemnum.Length = 0 Then Return False
                    End If
                    lblItemNo.Text = itemnum
                End If

                '*** o^̎s
                Dim sSQL2 As String = "INSERT INTO T_d" & _
                        " (ʔ, N, ؕC, ݕC, z, Ev)" & _
                    " VALUES (@itemnum2, @ymd2, @debtor2, @creditor2, @yen2, @complement2)"
                Using cmd2 As New OleDbCommand(sSQL2, cn)
                    cmd2.Parameters.AddWithValue("@itemnum2", itemnum)
                    cmd2.Parameters.AddWithValue("@ymd2", _ymd)
                    cmd2.Parameters.AddWithValue("@debtor2", vdebtor)
                    cmd2.Parameters.AddWithValue("@creditor2", vcreditor)
                    cmd2.Parameters.AddWithValue("@yen2", vyen)
                    cmd2.Parameters.AddWithValue("@complement2", vcomplement)
                    cmd2.Transaction = tran
                    cmd2.ExecuteNonQuery()
                End Using

                If vdebtor = AcCodeCommute Then
                    '*** ؕʔ̏ꍇ
                    Dim sSQL3 As String = "INSERT INTO T_ʔ1 (ʔ, , ؑ)" & _
                                        " VALUES(@itemnum3, @detail3, @decr3)"
                    Using cmd3 As New OleDbCommand(sSQL3, cn)
                        cmd3.Parameters.AddWithValue("@itemnum3", itemnum)
                        cmd3.Parameters.AddWithValue("@detail3", String.Empty)
                        cmd3.Parameters.AddWithValue("@decr3", DECR_DE)
                        cmd3.Transaction = tran
                        cmd3.ExecuteNonQuery()
                    End Using

                ElseIf vcreditor = AcCodeCommute Then
                    '*** ݕʔ̏ꍇ
                    Dim sSQL4 As String = "INSERT INTO T_ʔ1 (ʔ, , ؑ)" & _
                                        " VALUES(@itemnum4, @detail4, @decr4)"
                    Using cmd4 As New OleDbCommand(sSQL4, cn)
                        cmd4.Parameters.AddWithValue("@itemnum4", itemnum)
                        cmd4.Parameters.AddWithValue("@detail4", String.Empty)
                        cmd4.Parameters.AddWithValue("@decr4", DECR_CR)
                        cmd4.Transaction = tran
                        cmd4.ExecuteNonQuery()
                    End Using
                End If

            Catch ex As Exception
                tran.Rollback()
                cn.Close()
                FormEnabled(Me)
                ShowCatchMsg(F_NAME, method, ex)
                Return False

            End Try

            tran.Commit()
            cn.Close()
        End Using

        FormEnabled(Me)
        Return True
    End Function

    ''' <summary>
    ''' [ClearData]\bh
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub ClearData()

        grdView.ClearSelection()
        'dtpJournal.Value = Date.Now  ' Ver1.1.1ŃRgAEg
        If grdView.Rows.Count > 0 Then
            grdView.FirstDisplayedScrollingRowIndex = grdView.Rows.Count - 1
        End If

        'lblItemNo.Text = String.Empty
        cbxDebtor.SelectedIndex = -1
        cbxCreditor.SelectedIndex = -1
        txtYen.Text = String.Empty
        txtComplement.Text = String.Empty
        rdoAdd.Checked = True
        dtpJournal.Focus()
    End Sub

    ''' <summary>
    ''' [FillCbxDeCre]\bh
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub FillCbxDeCre()

        Dim sSQL As String = "SELECT ȖC, Ȗ" & _
                            " FROM T_Ȗڃ}X^" & _
                            " ORDER BY ȖC"
        Using cn As New OleDbConnection(CnSt)
            Using da As New OleDbDataAdapter(sSQL, cn)
                Dim dt As New DataTable
                da.Fill(dt)

                With dt
                    If .Rows.Count > 0 Then
                        For i As Integer = 0 To .Rows.Count - 1
                            Dim code As String = .Rows(i).Item("ȖC").ToString
                            Dim account As String = .Rows(i).Item("Ȗ").ToString
                            cbxDebtor.Items.Add(code & ") " & account)
                            cbxCreditor.Items.Add(code & ") " & account)
                        Next
                    End If
                End With
            End Using
        End Using
    End Sub

    ''' <summary>
    ''' [InitializeForm]\bh
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub InitializeForm()

        FillCbxDeCre()
        dtpJournal.MaxDate = New Date(MaxYear, 12, 31)
        dtpJournal.MinDate = New Date(MinYear, 1, 1)
        dtpJournal.Value = Date.Now

        SetGridProperty(grdView)
        rdoAdd.Checked = True
    End Sub

    ''' <summary>
    ''' [PrintTable]\bh
    ''' </summary>
    ''' <param name="vdt"></param>
    ''' <param name="vterm"></param>
    ''' <remarks></remarks>
    Private Sub PrintTable(ByVal vdt As DataTable, ByVal vterm As String)

        Const ORIGINAL_FILE As String = "d󒠌.xls"
        Const TARGET_FILE As String = "d.xls"

        Dim method As String = New StackFrame(0).GetMethod.Name
        Dim target As String = FILE_FOLDER & TARGET_FILE
        Dim original As String = FILE_FOLDER & ORIGINAL_FILE
        If Not System.IO.File.Exists(original) Then
            ShowMsg("[" & original & "]܂B", MSG_EXC)
            Exit Sub
        End If

        Dim dt As DataTable = vdt
        Dim exlapp As New Excel.Application
        Try
            exlapp.Visible = False
            'exlapp.Visible = True
            Try
                exlapp.Workbooks.Open(original)
            Catch ex As Exception
                exlapp.Quit()
                exlapp = Nothing
                ShowMsg("[" & ORIGINAL_FILE & "]ĂB", MSG_EXC)
                Exit Sub
            End Try

            exlapp.DisplayAlerts = False
            Dim book1 As Excel.Workbook = exlapp.ActiveWorkbook
            Try
                book1.SaveAs(target)
            Catch ex As Exception
                book1.Close()
                book1 = Nothing
                exlapp.Quit()
                exlapp = Nothing
                ShowMsg("[" & TARGET_FILE & "]ĂB", MSG_EXC)
                Exit Sub
            End Try
            exlapp.DisplayAlerts = True

            Dim sheet1 As Excel.Worksheet = CType(book1.Worksheets(1), Excel.Worksheet)
            With sheet1
                .Cells(3, "A") = vterm
                Dim iend As Integer = 5
                If dt.Rows.Count > 0 Then
                    For i As Integer = 0 To dt.Rows.Count - 1
                        .Cells(i + 5, "A") = dt.Rows(i)("N")
                        .Cells(i + 5, "B") = dt.Rows(i)("ؕ")
                        .Cells(i + 5, "C") = dt.Rows(i)("ݕ")
                        .Cells(i + 5, "D") = dt.Rows(i)("z")
                        .Cells(i + 5, "E") = dt.Rows(i)("Ev")
                        iend = i + 5
                    Next
                End If
                .Range("A5", .Cells(iend, "E")).Borders.LineStyle = Excel.XlLineStyle.xlContinuous
                .PrintOut()
            End With

            exlapp.DisplayAlerts = False
            book1.Save()
            book1.Close()
            book1 = Nothing
            exlapp.DisplayAlerts = True
            exlapp.Quit()
            exlapp = Nothing

            ShowMsg("I܂B", MSG_INF)

        Catch ex As Exception

            exlapp.DisplayAlerts = False
            For Each wbook As Excel.Workbook In exlapp.Workbooks
                wbook.Close()
            Next
            exlapp.DisplayAlerts = True
            exlapp.Quit()
            exlapp = Nothing

            ShowCatchMsg(F_NAME, method, ex)
        End Try
    End Sub

    ''' <summary>
    ''' [SetGridScroll]\bh
    ''' </summary>
    ''' <param name="vdata"></param>
    ''' <remarks></remarks>
    Private Sub SetGridScroll(ByVal vdata As String)

        If grdView.RowCount > 0 Then
            For i As Integer = 0 To grdView.Rows.Count - 1
                If (grdView.Rows(i).Cells("ʔ").Value).ToString = vdata Then
                    grdView.Rows(i).Selected = True
                    grdView.FirstDisplayedScrollingRowIndex = i
                    Exit For
                End If
            Next
        End If
    End Sub

    ''' <summary>
    ''' [ShowGrid]\bh
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub ShowGrid()

        Dim method As String = New StackFrame(0).GetMethod.Name

        If Not _dt Is Nothing Then
            _dt.Clear()
            grdView.DataSource = Nothing
        End If

        Dim syear As String = lblYear.Text
        Dim sSQL As String = "SELECT ʔ," & _
                                    " N," & _
                                    " ؕC," & _
                                    " ؕ," & _
                                    " ݕC," & _
                                    " ݕ," & _
                                    " z," & _
                                    " Ev" & _
                                " FROM V_d" & _
                                " WHERE N LIKE @year" & _
                                " ORDER BY N, ʔ"

        Try
            Using cn As New OleDbConnection(CnSt)
                Dim da As New OleDbDataAdapter(sSQL, cn)
                da.SelectCommand.Parameters.AddWithValue("@year", syear & "%")
                _dt = New DataTable()
                da.Fill(_dt)

                If _dt.Rows.Count = 0 Then
                    lblMsg.Visible = True
                    grdView.Visible = False
                    btnPrint.Enabled = False

                Else
                    lblMsg.Visible = False
                    With grdView
                        .Visible = True
                        .DataSource = _dt
                        .Columns("ʔ").Visible = False
                        .Columns("N").Width = 90
                        .Columns("ؕC").Visible = False
                        .Columns("ؕ").Width = 120
                        .Columns("ݕC").Visible = False
                        .Columns("ݕ").Width = 120
                        .Columns("z").Width = 110
                        .Columns("z").DefaultCellStyle.Alignment = _
                                DataGridViewContentAlignment.MiddleRight
                        .Columns("z").DefaultCellStyle.Format = "#,##0"
                        .Columns("Ev").Width = 150
                        .ClearSelection()
                    End With
                    btnPrint.Enabled = True
                End If
            End Using

        Catch ex As Exception
            ShowCatchMsg(F_NAME, method, ex)
        End Try
    End Sub

End Class