Imports CKAccount.CC
Imports System.Data.OleDb

Public Class F3200_BSPL

    Enum TableType
        BS
        PL
        Sales
    End Enum

    Const F_NAME As String = "BSPL"
    Const LEN_DNO As Integer = 3             ' BS, PL DNoŁAN̉̌

    Private _cn As OleDbConnection
    Private _dt1 As DataTable
    Private _dt2 As DataTable
    Private _dt3 As DataTable
    Private _dtWork As Boolean = False
    Private _initial As Boolean = True       ' Form_Load̋Nx̂߂Ɏgp
    Private _tabletype As TableType
    Private _title As String = String.Empty
    Private _year As String                  ' cbxYear_SIChanged Ŏ擾


    ''' <summary>
    ''' [߂]{^NbNCxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="eventArgs"></param>
    ''' <remarks></remarks>
    Private Sub btnBack_Click(ByVal sender As System.Object, _
            ByVal eventArgs As System.EventArgs) Handles btnBack.Click
        Me.Close()
    End Sub

    ''' <summary>
    ''' [폜]{^NbNCxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnDelete_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles btnDelete.Click

        If MsgCanceled("Nx̌Z\폜܂B") Then Exit Sub

        If DeleteTable() Then
            UpdateDB = True
            btnDelete.Enabled = False
            btnPrint.Enabled = False
            chkCreate.Checked = False
            btnCreate.Enabled = True
            grdView.Visible = False
            grdView.DataSource = Nothing
            lblTitle.Visible = False
            lblMsg.Text = "[쐬]{^NbNĂ"
            lblMsg.Visible = True
            btnCreate.Focus()
        End If
    End Sub

    ''' <summary>
    ''' []{^NbNCxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnPrint_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles btnPrint.Click

        PrintTable(_title, _tabletype)
    End Sub

    ''' <summary>
    ''' [쐬]{^NbNCxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnCreate_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles btnCreate.Click

        lblMsg.Visible = False
        If Not CreateTable() Then
            lblMsg.Visible = True
            Exit Sub
        End If

        If GetDataTable() Then
            UpdateDB = True
            btnDelete.Enabled = True
            chkCreate.Checked = True
            btnCreate.Enabled = False
            lblMsg.Visible = False
        Else
            lblMsg.Visible = True
        End If
    End Sub

    ''' <summary>
    ''' [cbxYear_KeyDown]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub cbxYear_KeyDown(ByVal sender As System.Object, _
            ByVal e As KeyEventArgs) Handles cbxYear.KeyDown
        CtrlKeyDown(Me, e)
    End Sub

    ''' <summary>
    ''' [cbxYear_SIChanged]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub cbxYear_SIChanged(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles cbxYear.SelectedIndexChanged

        Dim method As String = New StackFrame(0).GetMethod.Name

        Try
            If cbxYear.SelectedIndex < 0 Then Exit Sub

            _year = cbxYear.Text

            lblTitle.Visible = False
            lblTitle.Text = String.Empty
            lblMsg.Visible = False
            grdView.Visible = False
            grdView.DataSource = Nothing

            btnDelete.Enabled = False
            btnPrint.Enabled = False
            btnCreate.Enabled = False
            chkCreate.Checked = False

            '*** Nx[T_d]f[^̑݊mF
            If Not CheckJournal() Then
                lblMsg.Text = "Nx̎df[^͓͂Ă܂"
                lblMsg.Visible = True
                btnBack.Focus()
                Exit Sub
            End If

            '*** Nx[T_Z\]f[^̑݊mF
            If Not CheckTB() Then
                lblMsg.Text = "Nx̐Z\͍쐬Ă܂"
                lblMsg.Visible = True
                btnBack.Focus()
                Exit Sub
            End If

            '*** [T_ݎؑΏƕ\]A[T_vvZ]A[T_ʔ]̓Nxf[^̑݊mF
            If Not CheckTables() Then
                btnCreate.Enabled = True
                lblMsg.Text = "[쐬]{^NbNĂ"
                lblMsg.Visible = True
                btnCreate.Focus()

            Else
                If GetDataTable() Then
                    chkCreate.Checked = True
                    btnDelete.Enabled = True
                End If
            End If

        Catch ex As Exception
            ShowCatchMsg(F_NAME, method, ex)
        End Try
    End Sub

    ''' <summary>
    ''' [chkCreate_CheckedChanged]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub chkCreate_CheckedChanged(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles chkCreate.CheckedChanged

        If chkCreate.Checked Then
            rdoBS.Enabled = True
            rdoPL.Enabled = True
            rdoSales.Enabled = True
            rdoBS.Checked = True
            _initial = False           ' Form_Load̋Nx̂߂Ɏgp
        Else
            rdoBS.Checked = False
            rdoPL.Checked = False
            rdoSales.Checked = False
            rdoBS.Enabled = False
            rdoPL.Enabled = False
            rdoSales.Enabled = False
        End If
    End Sub

    ''' <summary>
    ''' [Form_Closing]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Form_Closing(ByVal sender As Object, _
            ByVal e As FormClosingEventArgs) Handles Me.FormClosing

        If _dtWork Then
            _dt1.Clear()
            _dt2.Clear()
            _dt3.Clear()
        End If
        F1000_Menu.Show()
    End Sub

    ''' <summary>
    ''' [Form_Load]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Form_Load(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles MyBase.Load

        SetForm(Me)
        InitializeForm()
    End Sub

    ''' <summary>
    ''' [RdoBtn_CheckedChanged]Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub RdoBtn_CheckedChanged(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles _
            rdoSales.CheckedChanged, rdoPL.CheckedChanged, rdoBS.CheckedChanged

        If _initial Then Exit Sub ' Form_Load̋Nx̂߂Ɏgp
        If Not CType(sender, RadioButton).Checked Then Exit Sub

        If sender Is rdoBS Then
            _tabletype = TableType.BS
        ElseIf sender Is rdoPL Then
            _tabletype = TableType.PL
        Else
            _tabletype = TableType.Sales
        End If

        RBtnChangedEvent()
    End Sub


    ''' <summary>
    ''' [CheckJournal]\bh
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks>[cbxYear_SIChanged]ďo</remarks>
    Private Function CheckJournal() As Boolean

        Dim method As String = New StackFrame(0).GetMethod.Name

        Try

            Using cn As New OleDbConnection(CnSt)
                Dim sSQL As String = "SELECT ʔ" & _
                                    " FROM T_d" & _
                                    " WHERE N LIKE @year"
                Using da As New OleDbDataAdapter(sSQL, cn)
                    da.SelectCommand.Parameters.AddWithValue("@year", _year & "%")
                    Dim dt As New DataTable
                    da.Fill(dt)
                    If dt.Rows.Count = 0 Then Return False
                End Using
            End Using
            Return True

        Catch ex As Exception
            ShowCatchMsg(F_NAME, method, ex)
            Return False

        End Try
    End Function

    ''' <summary>
    ''' [CheckTables]\bh
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks>[cbxYear_SIChanged]ďo</remarks>
    Private Function CheckTables() As Boolean

        Dim method As String = New StackFrame(0).GetMethod.Name

        Try
            Using cn As New OleDbConnection(CnSt)
                '*** [T_ݎؑΏƕ\]̃f[^̑݊mF
                Dim sSQL1 As String = "SELECT DNo" & _
                                    " FROM T_ݎؑΏƕ\" & _
                                    " WHERE DNo LIKE @year1"
                Using da1 As New OleDbDataAdapter(sSQL1, cn)
                    da1.SelectCommand.Parameters.AddWithValue("year1", _year & "%")
                    Dim dt1 As New DataTable
                    da1.Fill(dt1)
                    If dt1.Rows.Count = 0 Then Return False
                End Using

                '*** [T_vvZ]̃f[^̑݊mF
                Dim sSQL2 As String = "SELECT DNo" & _
                                    " FROM T_vvZ" & _
                                    " WHERE DNo LIKE @year2"
                Using da2 As New OleDbDataAdapter(sSQL2, cn)
                    da2.SelectCommand.Parameters.AddWithValue("year2", _year & "%")
                    Dim dt2 As New DataTable
                    da2.Fill(dt2)
                    If dt2.Rows.Count = 0 Then Return False
                End Using

                '*** [T_ʔ]̃f[^̑݊mF
                Dim sSQL3 As String = "SELECT DNo" & _
                                    " FROM T_ʔ" & _
                                    " WHERE DNo LIKE @year3"
                Using da3 As New OleDbDataAdapter(sSQL3, cn)
                    da3.SelectCommand.Parameters.AddWithValue("year3", _year & "%")
                    Dim dt3 As New DataTable
                    da3.Fill(dt3)
                    If dt3.Rows.Count = 0 Then Return False
                End Using
            End Using
            Return True

        Catch ex As Exception
            ShowCatchMsg(F_NAME, method, ex)
            Return False

        End Try
    End Function

    ''' <summary>
    ''' [CheckTB]\bh
    '''  Nx[T_Z\]݂̑Ԃ
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks>[cbxYear_SIChanged]ďo</remarks>
    Private Function CheckTB() As Boolean

        Dim method As String = New StackFrame(0).GetMethod.Name
        Dim result As Boolean = False

        Try
            Using cn As New OleDbConnection(CnSt)
                Dim sSQL As String = "SELECT ȖC" & _
                                    " FROM T_Z\" & _
                                    " WHERE Nx = @year"
                Using da As New OleDbDataAdapter(sSQL, cn)
                    da.SelectCommand.Parameters.AddWithValue("@year", _year)
                    Dim dt As New DataTable
                    da.Fill(dt)
                    If dt.Rows.Count > 0 Then result = True
                End Using
            End Using

        Catch ex As Exception
            ShowCatchMsg(F_NAME, method, ex)
            result = False
        End Try

        Return result
    End Function

    ''' <summary>
    ''' [CreateTable]\bh
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks>[btnCreate_Click]ďo</remarks>
    Private Function CreateTable() As Boolean

        If Not DeleteTable() Then Return False

        FormDisabled(Me)

        _cn = New OleDbConnection(CnSt)
        _cn.Open()

        If Not PutIntoBS() Then
            _cn.Close()
            _cn = Nothing
            Return False
        End If

        If Not PutIntoPL() Then
            _cn.Close()
            _cn = Nothing
            Return False
        End If

        If Not PutIntoSales() Then
            _cn.Close()
            _cn = Nothing
            Return False
        End If

        _cn.Close()
        _cn = Nothing

        FormEnabled(Me)

        Return True
    End Function

    ''' <summary>
    ''' [DeleteTable]\bh
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks>[btnDelete_Click],[CreateTable]ďo</remarks>
    Private Function DeleteTable() As Boolean

        Dim method As String = New StackFrame(0).GetMethod.Name

        FormDisabled(Me)

        Using cn As New OleDbConnection(CnSt)
            cn.Open()

            Dim tran As OleDbTransaction = cn.BeginTransaction
            Try
                Dim sSQL1 As String = "DELETE FROM T_ݎؑΏƕ\" & _
                                    " WHERE DNo LIKE @year1"
                Using cmd1 As New OleDbCommand(sSQL1, cn)
                    cmd1.Parameters.AddWithValue("@year1", _year & "%")
                    cmd1.Transaction = tran
                    cmd1.ExecuteNonQuery()
                End Using

                Dim sSQL2 As String = "DELETE FROM T_vvZ" & _
                                    " WHERE DNo LIKE @year2"
                Using cmd2 As New OleDbCommand(sSQL2, cn)
                    cmd2.Parameters.AddWithValue("@year2", _year & "%")
                    cmd2.Transaction = tran
                    cmd2.ExecuteNonQuery()
                End Using

                Dim sSQL3 As String = "DELETE FROM T_ʔ" & _
                                    " WHERE DNo LIKE @year3"
                Using cmd3 As New OleDbCommand(sSQL3, cn)
                    cmd3.Parameters.AddWithValue("@year3", _year & "%")
                    cmd3.Transaction = tran
                    cmd3.ExecuteNonQuery()
                End Using

                tran.Commit()
                cn.Close()
                FormEnabled(Me)
                Return True

            Catch ex As Exception
                tran.Rollback()
                cn.Close()
                FormEnabled(Me)
                ShowCatchMsg(F_NAME, method, ex)
                Return False

            End Try
        End Using
    End Function

    ''' <summary>
    ''' [GetDataTable]\bh
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks>[btnCreate_Click],[cbxYear_SIChanged]ďo</remarks>
    Private Function GetDataTable() As Boolean

        Dim method As String = New StackFrame(0).GetMethod.Name

        FormDisabled(Me)
        Try
            If _dtWork Then
                _dt1.Clear()
                _dt2.Clear()
                _dt3.Clear()
                _dtWork = False
            End If

            Dim cn As New OleDbConnection(CnSt)

            '*** [ݎؑΏƕ\]̃f[^e[u쐬
            Dim sSQL1 As String = "SELECT ؕȖ, ؕz, ݕȖ, ݕz" & _
                                " FROM T_ݎؑΏƕ\" & _
                                " WHERE DNo LIKE @year1" & _
                                " ORDER BY DNo"
            Dim da1 As New OleDbDataAdapter(sSQL1, cn)
            da1.SelectCommand.Parameters.AddWithValue("@year1", _year & "%")
            _dt1 = New DataTable
            da1.Fill(_dt1)

            '*** [vvZ]̃f[^e[u쐬
            Dim sSQL2 As String = "SELECT Ȗ1 AS , Ȗ2 AS Ȗ, z" & _
                                " FROM T_vvZ" & _
                                " WHERE DNo LIKE @year2" & _
                                " ORDER BY DNo"
            Dim da2 As New OleDbDataAdapter(sSQL2, cn)
            da2.SelectCommand.Parameters.AddWithValue("@year2", _year & "%")
            _dt2 = New DataTable
            da2.Fill(_dt2)

            '*** [ʔz]f[^e[u쐬
            Dim sSQL3 As String = "SELECT , z" & _
                                " FROM T_ʔ" & _
                                " WHERE DNo LIKE @year3" & _
                                " ORDER BY DNo"
            Dim da3 As New OleDbDataAdapter(sSQL3, cn)
            da3.SelectCommand.Parameters.AddWithValue("@year3", _year & "%")
            _dt3 = New DataTable
            da3.Fill(_dt3)

            _dtWork = True

            FormEnabled(Me)
            Return True

        Catch ex As Exception
            FormEnabled(Me)
            ShowCatchMsg(F_NAME, method, ex)
            Return False

        End Try
    End Function

    ''' <summary>
    ''' [PutIntoBS]\bh
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks>[CreateTable]ďo</remarks>
    Private Function PutIntoBS() As Boolean

        Dim method As String = New StackFrame(0).GetMethod.Name

        Dim yen As Decimal

        Try
            '*** [V_Z\]̎YȖڂ̏Wv
            Dim sumAsset As Decimal = 0
            Dim lstAsset As New List(Of String)
            Dim sSQL1 As String = "SELECT Ȗ, z" & _
                                " FROM V_Z\" & _
                                " WHERE Nx = @year1 AND  = 'Y'" & _
                                " ORDER BY ȖC"
            Using da1 As New OleDbDataAdapter(sSQL1, _cn)
                da1.SelectCommand.Parameters.AddWithValue("@year1", _year)
                Dim dt1 As New DataTable
                da1.Fill(dt1)
                If dt1.Rows.Count > 0 Then
                    For i1 As Integer = 0 To dt1.Rows.Count - 1
                        yen = Convert.ToDecimal(dt1.Rows(i1)("z"))
                        sumAsset += yen
                        lstAsset.Add(ApoStr(dt1.Rows(i1)("Ȗ").ToString) & ", " & yen.ToString)
                    Next
                End If
            End Using
            Dim sumRow As String = "'@v', " & sumAsset.ToString & _
                ", '@v', " & sumAsset.ToString
            Dim countAsset As Integer = lstAsset.Count

            '*** [V_Z\]̕Ȗڂ̏Wv
            Dim sumDebt As Decimal = 0
            Dim lstDebt As New List(Of String)
            Dim sSQL2 As String = "SELECT Ȗ, z" & _
                                " FROM V_Z\" & _
                                " WHERE Nx = @year2 AND  = ''" & _
                                " ORDER BY ȖC"
            Using da2 As New OleDbDataAdapter(sSQL2, _cn)
                da2.SelectCommand.Parameters.AddWithValue("@year2", _year)
                Dim dt2 As New DataTable
                da2.Fill(dt2)
                If dt2.Rows.Count > 0 Then
                    For i2 As Integer = 0 To dt2.Rows.Count - 1
                        yen = Convert.ToDecimal(dt2.Rows(i2)("z"))
                        sumDebt += yen
                        lstDebt.Add(ApoStr(dt2.Rows(i2)("Ȗ").ToString) & ", " & _
                            yen.ToString)
                    Next
                End If
            End Using
            Dim countDebt As Integer = lstDebt.Count

            '*** [V_Z\]̎{Ȗڂ̏Wv([O])
            Dim sumCapital As Decimal = 0
            Dim lstCapital As New List(Of String)
            Dim sSQL3 As String = "SELECT Ȗ, z" & _
                                " FROM V_Z\" & _
                                " WHERE Nx = @year3 AND  = '{'" & _
                                    " AND ȖC <> @code3" & _
                                " ORDER BY ȖC"
            Using da3 As New OleDbDataAdapter(sSQL3, _cn)
                da3.SelectCommand.Parameters.AddWithValue("@year3", _year)
                da3.SelectCommand.Parameters.AddWithValue("@code3", AcCodeProfitPY)
                Dim dt3 As New DataTable
                da3.Fill(dt3)
                If dt3.Rows.Count > 0 Then
                    For i3 As Integer = 0 To dt3.Rows.Count - 1
                        yen = Convert.ToDecimal(dt3.Rows(i3)("z"))
                        sumCapital += yen
                        lstCapital.Add(ApoStr(dt3.Rows(i3)("Ȗ").ToString) & "," & _
                            yen.ToString)
                    Next
                End If
            End Using
            lstCapital.Add("'TO', " & (sumAsset - sumDebt - sumCapital).ToString)
            Dim countCapital As Integer = lstCapital.Count

            Dim i As Integer

            '*** [T_ݎؑΏƕ\]ւ̏(Ver1.4.0ŏC)
            Dim dno As String = String.Empty
            If countAsset >= countDebt + countCapital Then
                Dim sSQL4 As String = String.Empty
                For i = 0 To countAsset
                    dno = _year & PadLeft0((i + 1).ToString, LEN_DNO)
                    If i < countDebt Then
                        sSQL4 = "INSERT INTO T_ݎؑΏƕ\" & _
                                    " (DNo, ؕȖ, ؕz, ݕȖ, ݕz)" & _
                                " VALUES (" & ApoStr(dno) & ", " & _
                                    lstAsset(i) & ", " & _
                                    lstDebt(i) & ")"
                    ElseIf i < countDebt + countCapital Then
                        sSQL4 = "INSERT INTO T_ݎؑΏƕ\" & _
                                    " (DNo, ؕȖ, ؕz, ݕȖ, ݕz)" & _
                                " VALUES (" & ApoStr(dno) & ", " & _
                                    lstAsset(i) & ", " & _
                                    lstCapital(i - countDebt) & ")"
                    ElseIf i = countAsset Then
                        sSQL4 = "INSERT INTO T_ݎؑΏƕ\" & _
                                    " (DNo, ؕȖ, ؕz, ݕȖ, ݕz)" & _
                                " VALUES (" & ApoStr(dno) & ", " & sumRow & ")"
                    Else
                        sSQL4 = "INSERT INTO T_ݎؑΏƕ\" & _
                                    " (DNo, ؕȖ, ؕz)" & _
                                " VALUES (" & ApoStr(dno) & ", " & _
                                    lstAsset(i) & ")"
                    End If
                    Using cmd4 As New OleDbCommand(sSQL4, _cn)
                        cmd4.ExecuteNonQuery()
                    End Using
                Next

            ElseIf countAsset > countDebt Then
                Dim sSQL5 As String = String.Empty
                For i = 0 To countDebt + countCapital
                    dno = _year & PadLeft0((i + 1).ToString, LEN_DNO)
                    If i < countDebt Then
                        sSQL5 = "INSERT INTO T_ݎؑΏƕ\" & _
                                    " (DNo, ؕȖ, ؕz, ݕȖ, ݕz)" & _
                                " VALUES (" & ApoStr(dno) & ", " & _
                                    lstAsset(i) & ", " & _
                                    lstDebt(i) & ")"
                    ElseIf i < countAsset Then
                        sSQL5 = "INSERT INTO T_ݎؑΏƕ\" & _
                                    " (DNo, ؕȖ, ؕz, ݕȖ, ݕz)" & _
                                " VALUES (" & ApoStr(dno) & ", " & _
                                    lstAsset(i) & ", " & _
                                    lstCapital(i - countDebt) & ")"
                    ElseIf i = countDebt + countCapital Then
                        sSQL5 = "INSERT INTO T_ݎؑΏƕ\" & _
                                    " (DNo, ؕȖ, ؕz, ݕȖ, ݕz)" & _
                                " VALUES (" & ApoStr(dno) & ", " & sumRow & ")"
                    Else
                        sSQL5 = "INSERT INTO T_ݎؑΏƕ\" & _
                                    " (DNo, ݕȖ, ݕz)" & _
                                " VALUES (" & ApoStr(dno) & ", " & _
                                    lstCapital(i - countDebt) & ")"
                    End If
                    Using cmd5 As New OleDbCommand(sSQL5, _cn)
                        cmd5.ExecuteNonQuery()
                    End Using
                Next

            Else
                Dim sSQL6 As String = String.Empty
                For i = 0 To countDebt + countCapital
                    dno = _year & PadLeft0((i + 1).ToString, LEN_DNO)
                    If i < countAsset Then
                        sSQL6 = "INSERT INTO T_ݎؑΏƕ\" & _
                                    " (DNo, ؕȖ, ؕz, ݕȖ, ݕz)" & _
                                " VALUES (" & ApoStr(dno) & ", " & _
                                    lstAsset(i) & ", " & _
                                    lstDebt(i) & ")"
                    ElseIf i < countDebt Then
                        sSQL6 = "INSERT INTO T_ݎؑΏƕ\" & _
                                    " (DNo, ݕȖ, ݕz)" & _
                                " VALUES (" & ApoStr(dno) & ", " & _
                                    lstDebt(i) & ")"
                    ElseIf i = countDebt + countCapital Then
                        sSQL6 = "INSERT INTO T_ݎؑΏƕ\" & _
                                   " (DNo, ؕȖ, ؕz, ݕȖ, ݕz)" & _
                               " VALUES (" & ApoStr(dno) & ", " & sumRow & ")"
                    Else
                        sSQL6 = "INSERT INTO T_ݎؑΏƕ\" & _
                                    " (DNo, ݕȖ, ݕz)" & _
                                " VALUES (" & ApoStr(dno) & ", " & _
                                    lstCapital(i - countDebt) & ")"
                    End If
                    Using cmd6 As New OleDbCommand(sSQL6, _cn)
                        cmd6.ExecuteNonQuery()
                    End Using
                Next
            End If
            Return True

        Catch ex As Exception
            FormEnabled(Me)
            ShowCatchMsg(F_NAME, method, ex)
            Return False

        End Try
    End Function

    ''' <summary>
    ''' [PutIntoPL]\bh
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks>[CreateTable]ďo</remarks>
    Private Function PutIntoPL() As Boolean

        Dim method As String = New StackFrame(0).GetMethod.Name

        Try
            Dim inum As Integer = 0   ' intNo
            Dim yen As Decimal
            Dim lstPL As New List(Of String)
            Dim dno As String = String.Empty      ' DNo
            '*** [V_Z\]̎Ȗڂ̏Wv
            Dim sumIncome As Decimal = 0
            Dim sSQL1 As String = "SELECT Ȗ, z" & _
                                " FROM V_Z\" & _
                                " WHERE Nx = @year1 AND  = ''" & _
                                " ORDER BY ȖC"
            Using da1 As New OleDbDataAdapter(sSQL1, _cn)
                da1.SelectCommand.Parameters.AddWithValue("@year1", _year)
                Dim dt1 As New DataTable
                da1.Fill(dt1)
                If dt1.Rows.Count > 0 Then
                    For i1 As Integer = 0 To dt1.Rows.Count - 1
                        inum += 1
                        dno = _year & PadLeft0(inum.ToString, LEN_DNO)
                        yen = Convert.ToDecimal(dt1.Rows(i1)("z"))
                        sumIncome += yen
                        lstPL.Add(ApoStr(dno) & ", '@@', " & _
                            ApoStr(dt1.Rows(i1)("Ȗ").ToString) & ", " & yen.ToString)
                    Next
                End If
            End Using
            inum += 1
            dno = _year & PadLeft0(inum.ToString, LEN_DNO)
            lstPL.Add(ApoStr(dno) & ", '@@', 'v', " & sumIncome.ToString)

            '*** [V_Z\]̌oȖڂ̏Wv
            Dim sumExpense As Decimal = 0
            Dim sSQL2 As String = "SELECT Ȗ, z" & _
                                " FROM V_Z\" & _
                                " WHERE Nx = @year2" & _
                                    " AND  = 'o'" & _
                                    " AND ȖC <> @code2" & _
                                " ORDER BY ȖC"
            Using da2 As New OleDbDataAdapter(sSQL2, _cn)
                da2.SelectCommand.Parameters.AddWithValue("@year2", _year)
                da2.SelectCommand.Parameters.AddWithValue("@code2", AcCodeShokuti)
                Dim dt2 As New DataTable
                da2.Fill(dt2)
                If dt2.Rows.Count > 0 Then
                    For i2 As Integer = 0 To dt2.Rows.Count - 1
                        inum += 1
                        dno = _year & PadLeft0(inum.ToString, LEN_DNO)
                        yen = Convert.ToDecimal(dt2.Rows(i2)("z"))
                        sumExpense += yen
                        lstPL.Add(ApoStr(dno) & ", 'o@@', " & _
                            ApoStr(dt2.Rows(i2)("Ȗ").ToString) & ", " & yen.ToString)
                    Next
                End If
            End Using
            inum += 1
            dno = _year & PadLeft0(inum.ToString, LEN_DNO)
            lstPL.Add(ApoStr(dno) & ", 'o@@', 'ov', " & sumExpense.ToString)

            '*** [z]s̒ǉ
            Dim profit As Decimal = sumIncome - sumExpense
            inum += 1
            dno = _year & PadLeft0(inum.ToString, LEN_DNO)
            lstPL.Add(ApoStr(dno) & ", 'z', '', " & profit.ToString)

            '*** [T_vvZ]ւ̏
            For i3 As Integer = 0 To inum - 1
                Dim sSQL3 As String = "INSERT INTO T_vvZ (DNo, Ȗ1, Ȗ2, z)" & _
                                    " VALUES (" & lstPL(i3) & ")"
                Using cmd3 As New OleDbCommand(sSQL3, _cn)
                    cmd3.ExecuteNonQuery()
                End Using
            Next

            Return True

        Catch ex As Exception
            FormEnabled(Me)
            ShowCatchMsg(F_NAME, method, ex)
            Return False

        End Try
    End Function

    ''' <summary>
    ''' [PutIntoSales]\bh
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks>[CreateTable]ďo</remarks>
    Private Function PutIntoSales() As Boolean

        Dim method As String = New StackFrame(0).GetMethod.Name

        Try
            Dim sumSales As Decimal = 0
            For i As Integer = 1 To 12
                Dim sYM As String = _year & PadLeft0(i.ToString, 2)
                Dim dsales As Decimal = 0
                Dim sSQL1 As String = "SELECT SUM(z) AS ݕ" & _
                                    " FROM T_d" & _
                                    " WHERE N LIKE @ym1 AND ݕC = @code1"
                Using da1 As New OleDbDataAdapter(sSQL1, _cn)
                    da1.SelectCommand.Parameters.AddWithValue("@ym1", sYM & "%")
                    da1.SelectCommand.Parameters.AddWithValue("@code1", AcCodeSales)
                    Dim dt1 As New DataTable
                    da1.Fill(dt1)
                    If dt1.Rows.Count > 0 Then
                        For i1 As Integer = 0 To dt1.Rows.Count - 1
                            If Not DBNull.Value.Equals(dt1.Rows(i1)("ݕ")) Then
                                dsales += Convert.ToDecimal(dt1.Rows(i1)("ݕ"))
                            End If
                        Next
                    End If
                End Using

                Dim sSQL2 As String = "SELECT SUM(z) AS ؕ" & _
                                    " FROM T_d" & _
                                    " WHERE N LIKE @ym2 AND ؕC = @code2"
                Using da2 As New OleDbDataAdapter(sSQL2, _cn)
                    da2.SelectCommand.Parameters.AddWithValue("@ym2", sYM & "%")
                    da2.SelectCommand.Parameters.AddWithValue("@code2", AcCodeSales)
                    Dim dt2 As New DataTable
                    da2.Fill(dt2)
                    If dt2.Rows.Count > 0 Then
                        For i2 As Integer = 0 To dt2.Rows.Count - 1
                            If Not DBNull.Value.Equals(dt2.Rows(i2)("ؕ")) Then
                                dsales -= Convert.ToDecimal(dt2.Rows(i2)("ؕ"))
                            End If
                        Next
                    End If
                End Using

                Dim sSQL3 As String = _
                    "INSERT INTO T_ʔ (DNo, , z)" & _
                    " VALUES (@dno3, @month3, @yen3)"
                Using cmd3 As New OleDbCommand(sSQL3, _cn)
                    cmd3.Parameters.AddWithValue("@dno3", _year & PadLeft0(i.ToString, 3))
                    cmd3.Parameters.AddWithValue("@month3", i.ToString)
                    cmd3.Parameters.AddWithValue("@yen3", dsales)
                    cmd3.ExecuteNonQuery()
                End Using

                sumSales += dsales
            Next

            Dim sSQL4 As String = _
                    "INSERT INTO T_ʔ (DNo, , z)" & _
                    " VALUES (@dno4, @month4, @yen4)"
            Using cmd4 As New OleDbCommand(sSQL4, _cn)
                cmd4.Parameters.AddWithValue("@dno4", _year & "013")
                cmd4.Parameters.AddWithValue("@month4", "v")
                cmd4.Parameters.AddWithValue("@yen4", sumSales)
                cmd4.ExecuteNonQuery()
            End Using

            Return True

        Catch ex As Exception
            FormEnabled(Me)
            ShowCatchMsg(F_NAME, method, ex)
            Return False
        End Try
    End Function

    ''' <summary>
    ''' [FillCbxYear]\bh
    ''' </summary>
    ''' <remarks>[InitializeForm]ďo</remarks>
    Private Sub FillCbxYear()

        Dim method As String = New StackFrame(0).GetMethod.Name

        Try
            For i As Integer = MinYear To MaxYear
                cbxYear.Items.Add(i.ToString)
            Next

        Catch ex As Exception
            ShowCatchMsg(F_NAME, method, ex)
        End Try
    End Sub

    ''' <summary>
    ''' [InitializeForm]\bh
    ''' </summary>
    ''' <remarks>[Form_Load]ďo</remarks>
    Private Sub InitializeForm()

        Dim method As String = New StackFrame(0).GetMethod.Name

        Try
            chkCreate.Checked = False
            FillCbxYear()
            cbxYear.Text = Year(Now).ToString

        Catch ex As Exception
            ShowCatchMsg(F_NAME, method, ex)
        End Try
        lblTitle.Visible = False
    End Sub

    ''' <summary>
    ''' [PrintTable]\bh
    ''' </summary>
    ''' <param name="vtitle"></param>
    ''' <param name="vtabletype"></param>
    ''' <remarks></remarks>
    Private Sub PrintTable(ByVal vtitle As String, ByVal vtabletype As TableType)

        Const TARGET_FILE1 As String = "ݎؑΏƕ\.xls"
        Const ORIGINAL_FILE1 As String = "ݎؑΏƕ\.xls"
        Const TARGET_FILE2 As String = "vvZ.xls"
        Const ORIGINAL_FILE2 As String = "vvZ.xls"
        Const TARGET_FILE3 As String = "ʔ\.xls"
        Const ORIGINAL_FILE3 As String = "ʔ\.xls"

        Dim method As String = New StackFrame(0).GetMethod.Name

        Dim dt As DataTable
        Dim originalFile As String = String.Empty
        Dim targetFile As String = String.Empty
        Select Case vtabletype
            Case TableType.BS
                dt = _dt1
                originalFile = ORIGINAL_FILE1
                targetFile = TARGET_FILE1
            Case TableType.PL
                dt = _dt2
                originalFile = ORIGINAL_FILE2
                targetFile = TARGET_FILE2
            Case Else
                dt = _dt3
                originalFile = ORIGINAL_FILE3
                targetFile = TARGET_FILE3
        End Select

        Dim target As String = FILE_FOLDER & targetFile
        Dim original As String = FILE_FOLDER & originalFile
        If Not System.IO.File.Exists(original) Then
            ShowMsg("[" & original & "]܂B", MSG_EXC)
            Exit Sub
        End If

        Dim exlapp As New Excel.Application
        Try
            exlapp.Visible = False
            'exlapp.Visible = True
            Try
                exlapp.Workbooks.Open(original)
            Catch ex As Exception
                exlapp.Quit()
                exlapp = Nothing
                ShowMsg("[" & originalFile & "]ĂB", MSG_EXC)
                Exit Sub
            End Try

            exlapp.DisplayAlerts = False
            Dim book1 As Excel.Workbook = exlapp.ActiveWorkbook
            Try
                book1.SaveAs(target)
            Catch ex As Exception
                book1.Close()
                book1 = Nothing
                exlapp.Quit()
                exlapp = Nothing
                ShowMsg("[" & targetFile & "]ĂB", MSG_EXC)
                Exit Sub
            End Try
            exlapp.DisplayAlerts = True

            Dim sheet1 As Excel.Worksheet = CType(book1.Worksheets(1), Excel.Worksheet)

            With sheet1
                Select Case vtabletype
                    Case TableType.BS
                        .Cells(3, "A") = vtitle
                        Dim istart1 As Integer = 6
                        Dim irow1 As Integer = istart1
                        If dt.Rows.Count > 0 Then
                            For i1 As Integer = 0 To dt.Rows.Count - 1
                                irow1 = i1 + istart1
                                .Cells(irow1, "A") = dt.Rows(i1)("ؕȖ")
                                .Cells(irow1, "B") = dt.Rows(i1)("ؕz")
                                .Cells(irow1, "C") = dt.Rows(i1)("ݕȖ")
                                .Cells(irow1, "D") = dt.Rows(i1)("ݕz")
                            Next
                        End If
                        .Range(.Cells(istart1, "A"), .Cells(irow1, "D")).Borders.LineStyle = _
                                Excel.XlLineStyle.xlContinuous

                    Case TableType.PL
                        .Cells(3, "A") = vtitle
                        Dim istart2 As Integer = 5
                        Dim irow2 As Integer = istart2
                        If dt.Rows.Count > 0 Then
                            For i2 As Integer = 0 To dt.Rows.Count - 1
                                irow2 = i2 + istart2
                                .Cells(irow2, "A") = dt.Rows(i2)("")
                                .Cells(irow2, "B") = dt.Rows(i2)("Ȗ")
                                .Cells(irow2, "C") = dt.Rows(i2)("z")
                            Next
                        End If
                        .Range(.Cells(istart2, "A"), .Cells(irow2, "C")).Borders.LineStyle = _
                                Excel.XlLineStyle.xlContinuous

                    Case Else
                        .Cells(2, "A") = vtitle
                        Dim istart3 As Integer = 5
                        Dim irow3 As Integer = istart3
                        If dt.Rows.Count > 0 Then
                            For i3 As Integer = 0 To dt.Rows.Count - 1
                                irow3 = i3 + istart3
                                .Cells(irow3, "A") = dt.Rows(i3)("")
                                .Cells(irow3, "B") = dt.Rows(i3)("z")
                            Next
                        End If
                        .Range(.Cells(istart3, "A"), .Cells(irow3, "B")).Borders.LineStyle = _
                                Excel.XlLineStyle.xlContinuous

                End Select

                .PrintOut()
            End With

            exlapp.DisplayAlerts = False
            book1.Save()
            book1.Close()
            book1 = Nothing
            exlapp.DisplayAlerts = True
            exlapp.Quit()
            exlapp = Nothing

            ShowMsg("I܂B", MSG_INF)

        Catch ex As Exception

            exlapp.DisplayAlerts = False
            For Each wbook As Excel.Workbook In exlapp.Workbooks
                wbook.Close()
            Next
            exlapp.DisplayAlerts = True
            exlapp.Quit()
            exlapp = Nothing

            ShowCatchMsg(F_NAME, method, ex)
        End Try
    End Sub

    ''' <summary>
    ''' [RBtnChangedEvent]\bh
    ''' </summary>
    ''' <remarks>[RdoBtn_CheckedChanged]ďo</remarks>
    Private Sub RBtnChangedEvent()

        Dim method As String = New StackFrame(0).GetMethod.Name

        Try
            grdView.DataSource = Nothing
            lblTitle.Visible = True
            grdView.Visible = True

            Select Case _tabletype
                Case TableType.BS
                    With grdView
                        .DataSource = _dt1
                        .Columns("ؕȖ").Width = 120
                        .Columns("ؕz").Width = 110
                        .Columns("ؕz").DefaultCellStyle.Alignment = _
                                DataGridViewContentAlignment.MiddleRight
                        .Columns("ؕz").DefaultCellStyle.Format = "#,##0"
                        .Columns("ݕȖ").Width = 120
                        .Columns("ݕz").Width = 110
                        .Columns("ݕz").DefaultCellStyle.Alignment = _
                                DataGridViewContentAlignment.MiddleRight
                        .Columns("ݕz").DefaultCellStyle.Format = "#,##0"
                    End With
                    lblTitle.Text = "    \"
                    _title = _year & "/12/31"

                Case TableType.PL
                    With grdView
                        .DataSource = _dt2
                        .Columns("").DefaultCellStyle.Alignment = _
                                DataGridViewContentAlignment.MiddleCenter
                        .Columns("Ȗ").Width = 180
                        .Columns("z").Width = 180
                        .Columns("z").DefaultCellStyle.Alignment = _
                                DataGridViewContentAlignment.MiddleRight
                        .Columns("z").DefaultCellStyle.Format = "#,##0"
                    End With
                    lblTitle.Text = " v v Z "
                    _title = _year & "/1/1 ` " & _year & "/12/31"

                Case Else
                    With grdView
                        .DataSource = _dt3
                        .Columns("").DefaultCellStyle.Alignment = _
                                DataGridViewContentAlignment.MiddleCenter
                        .Columns("z").Width = 360
                        .Columns("z").DefaultCellStyle.Alignment = _
                                DataGridViewContentAlignment.MiddleRight
                        .Columns("z").DefaultCellStyle.Format = "#,##0"
                    End With
                    lblTitle.Text = "     z"
                    _title = _year & "Nx      z"

            End Select

            SetGridProperty(grdView)
            btnPrint.Enabled = True

        Catch ex As Exception
            ShowCatchMsg(F_NAME, method, ex)
        End Try
    End Sub

End Class